define("net", [ "require", "exports", "module", "util", "events", "mailapi/worker-router" ], function(e, t) {
    function n(e, t, n) {
        var i = {
            onopen: this._onconnect.bind(this),
            onerror: this._onerror.bind(this),
            ondata: this._ondata.bind(this),
            onclose: this._onclose.bind(this)
        }, s = o.register(function(e) {
            i[e.cmd](e.args);
        });
        this._sendMessage = s.sendMessage, this._unregisterWithRouter = s.unregister;
        var a = [ t, e, {
            useSSL: n,
            useSecureTransport: n,
            binaryType: "arraybuffer"
        } ];
        this._sendMessage("open", a), r.call(this), this.destroyed = !1;
    }
    var i = e("util"), r = e("events").EventEmitter, s = e("mailapi/worker-router"), o = s.registerInstanceType("netsocket");
    t.NetSocket = n, i.inherits(n, r), n.prototype.setTimeout = function() {}, n.prototype.setKeepAlive = function() {}, 
    n.prototype.write = function(e) {
        if (e instanceof Blob) return this._sendMessage("write", [ e ]), void 0;
        if (0 !== e.byteOffset || e.length !== e.buffer.byteLength) {
            var t = e.buffer.slice(e.byteOffset, e.byteOffset + e.length);
            this._sendMessage("write", [ t, 0, t.byteLength ], [ t ]);
        } else this._sendMessage("write", [ e.buffer, e.byteOffset, e.length ]);
    }, n.prototype.upgradeToSecure = function() {
        this._sendMessage("upgradeToSecure", []);
    }, n.prototype.end = function() {
        this.destroyed || (this._sendMessage("end"), this.destroyed = !0, this._unregisterWithRouter());
    }, n.prototype._onconnect = function() {
        this.emit("connect");
    }, n.prototype._onerror = function(e) {
        this.emit("error", e);
    }, n.prototype._ondata = function(e) {
        var t = Buffer(e);
        this.emit("data", t);
    }, n.prototype._onclose = function() {
        this.emit("close"), this.emit("end");
    }, t.connect = function(e, t, i) {
        return new n(e, t, !!i);
    };
}), define("tls", [ "net", "exports" ], function(e, t) {
    t.connect = function(t, n, i, r) {
        var s = new e.NetSocket(t, n, !0);
        return r && s.on("connect", r), s;
    };
}), define("imap", [ "require", "exports", "module", "util", "rdcommon/log", "net", "tls", "events", "mailparser/mailparser" ], function(e, t, n) {
    function i(e) {
        return parseInt(e, 10);
    }
    function r(e) {
        return e.replace($, function(e, t) {
            if (!t.length) return "&";
            t = t.replace(Q, "/");
            var n = new Buffer(t, "base64");
            return n.toString("utf-16be");
        });
    }
    function s(e) {
        var t = z.exec(e);
        if (!t) throw new Error("Not a good IMAP date-time: " + e);
        var n = parseInt(t[1], 10), i = F.indexOf(t[2]), r = parseInt(t[3], 10), s = parseInt(t[4], 10), o = parseInt(t[5], 10), a = parseInt(t[6], 10), c = Date.UTC(r, i, n, s, o, a), l = parseInt(t[7], 10), d = Math.floor(l / 100), u = l % 100;
        return c -= d * G + u * j;
    }
    function o(e) {
        var t;
        return t = (e.getDate() < 10 ? " " : "") + e.getDate() + "-" + F[e.getMonth()] + "-" + e.getFullYear() + " " + ("0" + e.getHours()).slice(-2) + ":" + ("0" + e.getMinutes()).slice(-2) + ":" + ("0" + e.getSeconds()).slice(-2) + (e.getTimezoneOffset() > 0 ? " -" : " +") + ("0" + Math.abs(e.getTimezoneOffset()) / 60).slice(-2) + ("0" + Math.abs(e.getTimezoneOffset()) % 60).slice(-2);
    }
    function a(e) {
        return this instanceof a ? (D.call(this), this._options = {
            username: "",
            password: "",
            host: "localhost",
            port: 143,
            secure: !1,
            connTimeout: 1e4,
            _logParent: null
        }, this._state = {
            status: B.NOCONNECT,
            conn: null,
            curId: 0,
            requests: [],
            unsentRequests: [],
            activeRequests: 0,
            postGreetingCallback: null,
            numCapRecvs: 0,
            isIdle: !0,
            tmrConn: null,
            curData: null,
            curDataMinLength: 0,
            curExpected: null,
            curXferred: 0,
            box: {
                _uidnext: 0,
                _flags: [],
                _newKeywords: !1,
                validity: 0,
                highestModSeq: void 0,
                keywords: [],
                permFlags: [],
                name: null,
                messages: {
                    total: 0,
                    "new": 0
                }
            },
            ext: {
                idle: {
                    MAX_WAIT: 174e4,
                    state: J,
                    timeWaited: 0
                }
            }
        }, this._unprocessed = [], this._options = x(this._options, e), this._LOG = this._options._logParent ? it.ImapProtoConn(this, this._options._logParent, Date.now() % 1e3) : null, 
        this._LOG && this._LOG.created(), this.delim = null, this.namespaces = {
            personal: [],
            other: [],
            shared: []
        }, this.capabilities = [], this.enabledCapabilities = [], this.blacklistedCapabilities = this._options.blacklistedCapabilities || [], 
        void 0) : new a(e);
    }
    function c() {}
    function l() {}
    function d(e, t, n) {
        for (var i = "", r = 0, s = e.length; s > r; r++) {
            var o = n ? e : e[r], a = null, c = n ? "" : " ";
            if ("string" == typeof o) o = o.toUpperCase(); else {
                if (!Array.isArray(o)) throw new Error("Unexpected search option data type. Expected string or array. Got: " + typeof o);
                o.length > 1 && (a = o.slice(1)), o.length > 0 && (o = o[0].toUpperCase());
            }
            if ("OR" === o) {
                if (2 !== a.length) throw new Error("OR must have exactly two arguments");
                i += " OR (" + d(a[0], t, !0) + ") (" + d(a[1], t, !0) + ")";
            } else switch ("!" === o[0] && (c += "NOT ", o = o.substr(1)), o) {
              case "ALL":
              case "ANSWERED":
              case "DELETED":
              case "DRAFT":
              case "FLAGGED":
              case "NEW":
              case "SEEN":
              case "RECENT":
              case "OLD":
              case "UNANSWERED":
              case "UNDELETED":
              case "UNDRAFT":
              case "UNFLAGGED":
              case "UNSEEN":
                i += c + o;
                break;

              case "BCC":
              case "BODY":
              case "CC":
              case "FROM":
              case "SUBJECT":
              case "TEXT":
              case "TO":
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                i += c + o + ' "' + b("" + a[0]) + '"';
                break;

              case "BEFORE":
              case "ON":
              case "SENTBEFORE":
              case "SENTON":
              case "SENTSINCE":
              case "SINCE":
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                if (!(a[0] instanceof Date) && "Invalid Date" === (a[0] = new Date(a[0])).toString()) throw new Error("Search option argument must be a Date object or a parseable date string");
                i += c + o + " " + a[0].getUTCDate() + "-" + F[a[0].getUTCMonth()] + "-" + a[0].getUTCFullYear();
                break;

              case "KEYWORD":
              case "UNKEYWORD":
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                i += c + o + " " + a[0];
                break;

              case "LARGER":
              case "SMALLER":
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                var l = parseInt(a[0]);
                if (isNaN(l)) throw new Error("Search option argument must be a number");
                i += c + o + " " + a[0];
                break;

              case "HEADER":
                if (!a || 2 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                i += c + o + ' "' + b("" + a[0]) + '" "' + b("" + a[1]) + '"';
                break;

              case "UID":
                if (!a) throw new Error("Incorrect number of arguments for search option: " + o);
                u(a), i += c + o + " " + a.join(",");
                break;

              case "X-GM-MSGID":
              case "X-GM-THRID":
                if (-1 === t.indexOf("X-GM-EXT-1")) throw new Error("IMAP extension not available: " + o);
                var h;
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                if (h = "" + a[0], !/^\d+$/.test(a[0])) throw new Error("Invalid value");
                i += c + o + " " + h;
                break;

              case "X-GM-RAW":
                if (-1 === t.indexOf("X-GM-EXT-1")) throw new Error("IMAP extension not available: " + o);
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                i += c + o + ' "' + b("" + a[0]) + '"';
                break;

              case "X-GM-LABELS":
                if (-1 === t.indexOf("X-GM-EXT-1")) throw new Error("IMAP extension not available: " + o);
                if (!a || 1 !== a.length) throw new Error("Incorrect number of arguments for search option: " + o);
                i += c + o + " " + a[0];
                break;

              default:
                throw new Error("Unexpected search option: " + o);
            }
            if (n) break;
        }
        return console.log("searchargs:", i), i;
    }
    function u(e) {
        for (var t, n = 0, i = e.length; i > n; n++) {
            if ("string" == typeof e[n]) {
                if ("*" === e[n] || "*:*" === e[n]) {
                    i > 1 && (e = [ "*" ]);
                    break;
                }
                if (/^(?:[\d]+|\*):(?:[\d]+|\*)$/.test(e[n])) continue;
            }
            if (t = parseInt("" + e[n]), isNaN(t)) throw new Error('Message ID/number must be an integer, "*", or a range: ' + e[n]);
            "number" != typeof e[n] && (e[n] = t);
        }
    }
    function h(e) {
        var t = [];
        if (!e.length) return t;
        for (var n, i, r = 0, s = -1, o = 1; o < e.length; o++) {
            var a = e.charCodeAt(o);
            if (48 === a) s = parseInt(e.substring(r, o)), r = ++o; else if ("44" === a) {
                if (-1 === s) t.push(parseInt(e.substring(r, o))); else for (n = parseInt(e.substring(r, o)), 
                i = s; n >= i; i++) t.push(i);
                s = -1, start = ++o;
            }
        }
        if (-1 === s) t.push(parseInt(e.substring(r, o))); else for (n = parseInt(e.substring(r, o)), 
        i = s; n >= i; i++) t.push(i);
        return t;
    }
    function p(e, t) {
        for (var n = S(e), i = 0; 3 > i; ++i) if (Array.isArray(n[i])) {
            for (var r = [], s = 0, o = n[i].length; o > s; ++s) {
                var a = {
                    prefix: n[i][s][0],
                    delim: n[i][s][1]
                };
                if (n[i][s].length > 2) {
                    a.extensions = [];
                    for (var c = 2, l = n[i][s].length; l > c; c += 2) a.extensions.push({
                        name: n[i][s][c],
                        flags: n[i][s][c + 1]
                    });
                }
                r.push(a);
            }
            0 === i ? t.personal = r : 1 === i ? t.other = r : 2 === i && (t.shared = r);
        }
    }
    function f(e, t, n) {
        for (var i = S(e), r = 0, o = i.length; o > r; r += 2) if ("UID" === i[r]) n.id = parseInt(i[r + 1], 10); else if ("INTERNALDATE" === i[r]) n.rawDate = i[r + 1], 
        n.date = s(i[r + 1]); else if ("FLAGS" === i[r]) n.flags = i[r + 1].filter(y), n.flags.sort(); else if ("MODSEQ" === i[r]) n.modseq = i[r + 1].slice(1, -1); else if ("BODYSTRUCTURE" === i[r]) n.structure = m(i[r + 1]); else if ("string" == typeof i[r]) n[i[r].toLowerCase()] = i[r + 1]; else if (Array.isArray(i[r]) && "string" == typeof i[r][0] && 0 === i[r][0].indexOf("HEADER") && t) {
            var a = new L.MailParser();
            a._remainder = t, process.immediate = !0, a._process(!0), process.immediate = !1, 
            n.msg = a._currentNode;
        }
    }
    function m(e, t, n) {
        var i = [];
        if (void 0 === t) {
            var r = Array.isArray(e) ? e : S(e);
            r.length && (i = m(r, "", 1));
        } else {
            var s, o, a = e.length;
            if (Array.isArray(e[0])) {
                for (o = -1; Array.isArray(e[++o]); ) i.push(m(e[o], t + ("" !== t ? "." : "") + (n++).toString(), 1));
                if (s = {
                    type: "multipart",
                    subtype: e[o++].toLowerCase()
                }, a > o) {
                    if (Array.isArray(e[o])) {
                        s.params = {};
                        for (var c = 0, l = e[o].length; l > c; c += 2) s.params[e[o][c].toLowerCase()] = e[o][c + 1];
                    } else s.params = e[o];
                    ++o;
                }
            } else {
                if (o = 7, "string" == typeof e[1] ? s = {
                    partID: "" !== t ? t : "1",
                    type: e[0].toLowerCase(),
                    subtype: e[1].toLowerCase(),
                    params: null,
                    id: e[3],
                    description: e[4],
                    encoding: e[5],
                    size: e[6]
                } : (s = {
                    type: e[0].toLowerCase(),
                    params: null
                }, e.splice(1, 0, null), ++a, o = 2), Array.isArray(e[2])) {
                    s.params = {};
                    for (var c = 0, l = e[2].length; l > c; c += 2) s.params[e[2][c].toLowerCase()] = e[2][c + 1];
                    null === e[1] && ++o;
                }
                if ("message" === s.type && "rfc822" === s.subtype) {
                    if (a > o && Array.isArray(e[o])) {
                        s.envelope = {};
                        for (var c = 0, l = e[o].length; l > c; ++c) if (0 === c) s.envelope.date = e[o][c]; else if (1 === c) s.envelope.subject = e[o][c]; else if (c >= 2 && 7 >= c) {
                            var d = e[o][c];
                            if (Array.isArray(d)) {
                                for (var u, h = [], p = !1, f = 0, _ = d.length; _ > f; ++f) if (null === d[f][3]) p = !0, 
                                u = {
                                    group: d[f][2],
                                    addresses: []
                                }; else if (null === d[f][2]) p = !1, h.push(u); else {
                                    var v = {
                                        name: d[f][0],
                                        mailbox: d[f][2],
                                        host: d[f][3]
                                    };
                                    p ? u.addresses.push(v) : h.push(v);
                                }
                                d = h;
                            }
                            2 === c ? s.envelope.from = d : 3 === c ? s.envelope.sender = d : 4 === c ? s.envelope["reply-to"] = d : 5 === c ? s.envelope.to = d : 6 === c ? s.envelope.cc = d : 7 === c && (s.envelope.bcc = d);
                        } else if (8 === c) s.envelope["in-reply-to"] = e[o][c]; else {
                            if (9 !== c) break;
                            s.envelope["message-id"] = e[o][c];
                        }
                    } else s.envelope = null;
                    ++o, s.body = a > o && Array.isArray(e[o]) ? m(e[o], t + ("" !== t ? "." : "") + (n++).toString(), 1) : null, 
                    ++o;
                }
                ("text" === s.type || "message" === s.type && "rfc822" === s.subtype) && a > o && (s.lines = e[o++]), 
                "string" == typeof e[1] && a > o && (s.md5 = e[o++]);
            }
            g(s, a, e, o), i.unshift(s);
        }
        return i;
    }
    function g(e, t, n, i) {
        if (t > i) {
            var r = {
                type: null,
                params: null
            };
            if (Array.isArray(n[i])) {
                if (r.type = n[i][0], Array.isArray(n[i][1])) {
                    r.params = {};
                    for (var s = 0, o = n[i][1].length; o > s; s += 2) r.params[n[i][1][s].toLowerCase()] = n[i][1][s + 1];
                }
            } else null !== n[i] && (r.type = n[i]);
            e.disposition = null === r.type ? null : r, ++i;
        }
        t > i && (e.language = null !== n[i] ? Array.isArray(n[i]) ? n[i] : [ n[i] ] : null, 
        ++i), t > i && (e.location = n[i++]), t > i && (e.extensions = n[i]);
    }
    function _(e, t, n) {
        if (arguments.length < 3 || void 0 === arguments[1] || void 0 === arguments[2] || !t || "" === t || "function" == typeof t || "object" == typeof t) return !1;
        if (t = t === !0 ? "1" : t.toString(), !n || 0 === n) return e.split(t);
        if (0 > n) return !1;
        if (n > 0) {
            var i = e.split(t), r = i.splice(0, n - 1), s = i.join(t);
            return r.push(s), r;
        }
        return !1;
    }
    function v(e) {
        return e.trim().length > 0;
    }
    function y(e) {
        var t = e.trim();
        return t.length > 0 && !nt.test(t);
    }
    function b(e) {
        return e.replace(/\\/g, "\\\\").replace(/"/g, '\\"');
    }
    function w(e) {
        return e.toUpperCase();
    }
    function S(e, t, n) {
        n = n || 0;
        var i = !1, r = n - 1, s = !1;
        if (t || (t = new Array()), "string" == typeof e) {
            var o = new Object();
            o.str = e, e = o, s = !0;
        }
        for (var a = n, c = e.str.length; c > a; ++a) {
            if (i) '"' === e.str[a] && e.str[a - 1] && ("\\" !== e.str[a - 1] || e.str[a - 2] && "\\" === e.str[a - 2]) && (i = !1); else if ('"' === e.str[a]) i = !0; else if (" " === e.str[a] || ")" === e.str[a] || "]" === e.str[a]) {
                if (a - (r + 1) > 0 && t.push(E(e.str.substring(r + 1, a))), ")" === e.str[a] || "]" === e.str[a]) return a;
                r = a;
            } else if ("(" === e.str[a] || "[" === e.str[a]) {
                var l = [];
                a = S(e, l, a + 1), r = a, t.push(l);
            } else if ("{" === e.str[a]) {
                var d = e.str.indexOf("\r\n", a);
                if (-1 != d) {
                    var u = /\{(\d+)\}\r\n/.exec(e.str.substring(a, d + 2));
                    if (u) {
                        var h = parseInt(u[1], 10);
                        isNaN(h) || (t.push(E(e.str.substr(d + 2, h))), a = d + 2 + h - 1, r = a);
                    }
                }
            }
            a + 1 === c && c - (r + 1) > 0 && t.push(E(e.str.substring(r + 1)));
        }
        return s ? t : n;
    }
    function E(e) {
        if ('"' === e[0]) return e.substring(1, e.length - 1);
        if ("NIL" === e) return null;
        if (/^\d+$/.test(e)) {
            var t = parseInt(e, 10);
            return t.toString() === e ? t : e;
        }
        return e;
    }
    function x(e, t, n) {
        for (var i in t) n && i === n ? x(e[i], t[i]) : e[i] = t[i];
        return e;
    }
    function T(e, t) {
        var n = new Buffer(e.length + t.length);
        if (e.copy(n, 0, 0), Buffer.isBuffer(t)) t.copy(n, e.length, 0); else if (Array.isArray(t)) for (var i = e.length, r = t.length; r > i; i++) n[i] = t[i];
        return n;
    }
    function N(e, t) {
        for (var n = e.length - 1, i = t || 0; n > i; i++) if (13 === e[i] && 10 === e[i + 1]) return i;
        return -1;
    }
    var I = e("util"), C = e("rdcommon/log"), k = e("net"), A = e("tls"), D = e("events").EventEmitter, L = e("mailparser/mailparser"), M = function() {}, O = "\r\n", R = Buffer(O), B = {
        NOCONNECT: 0,
        NOGREET: 1,
        NOAUTH: 2,
        AUTH: 3,
        BOXSELECTING: 4,
        BOXSELECTED: 5
    }, F = [ "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" ], P = /^\* (\d+) FETCH/, q = / \{(\d+)}$/, H = /BODY\[(.*)\](?:\<\d+\>)?/, U = /UID (\d+)/, z = /^( ?\d|\d{2})-(.{3})-(\d{4}) (\d{2}):(\d{2}):(\d{2}) ([+-]\d{4})$/, G = 36e5, j = 6e4;
    const W = ("}".charCodeAt(0), "*".charCodeAt(0)), X = ")".charCodeAt(0);
    var Y = window.setTimeout.bind(window), V = window.clearTimeout.bind(window);
    t.TEST_useTimeoutFuncs = function(e, t) {
        Y = e, V = t;
    };
    var K = new Uint8Array(2e3);
    const $ = /&([^-]*)-/g, Q = /,/g;
    t.decodeModifiedUtf7 = r, t.parseImapDateTime = s;
    var J = 1, Z = 2, et = 3, tt = 4;
    I.inherits(a, D), t.ImapConnection = a, a.prototype.hasCapability = function(e) {
        return -1 !== this.capabilities.indexOf(e);
    }, a.prototype.blacklistCapability = function(e) {
        var t = this.blacklistedCapabilities;
        if (e = w(e), -1 === t.indexOf(e)) {
            t.push(e);
            var n = this.capabilities.indexOf(e);
            -1 !== n && this.capabilities.splice(n, 1);
        }
    }, a.prototype._findAndShiftRequestByPrefix = function(e) {
        var t = this._state.requests.length;
        e = e.trim();
        var n, i;
        for (i = 0; t > i; i++) if (n = this._state.requests[i], n && n.prefix && 0 === n.prefix.lastIndexOf(e, 0)) return this._state.requests.splice(i, 1)[0];
        if (this._state.requests.length > 1) {
            var r = [];
            for (i = 0; t > i; i++) n = this._state.requests[i], r.push(n.prefix);
        }
        return this._state.requests.shift();
    }, a.prototype._findFetchRequest = function(e, t) {
        for (var n, i = this._state.requests, r = i.length, s = 0; r > s; s++) if (n = i[s].fetchParams, 
        n && n.uids[e] && n.bodyPart === t) return i[s];
    }, a.prototype.connect = function(e) {
        function t(e) {
            var t = null;
            if ("*" === e[0]) {
                if (a._state.status === B.NOGREET) {
                    if ("PREAUTH" === e[1]) return a._state.status = B.AUTH, 0 === a._state.numCapRecvs && (a._state.numCapRecvs = 1), 
                    void 0;
                    if ("NO" === e[1] || "BAD" === e[1] || "BYE" === e[1]) return a._LOG && "BAD" === e[1] && a._LOG.bad(e[2]), 
                    a._state.conn.end(), void 0;
                    if (e[2].startsWith("[CAPABILITY ") && (a._state.numCapRecvs = 1, a.capabilities = e[2].substring(12, e[2].lastIndexOf("]")).split(" ").map(w)), 
                    a._state.status = B.NOAUTH, a._state.postGreetingCallback) {
                        var n = a._state.postGreetingCallback;
                        a._state.postGreetingCallback = null, n();
                    }
                    return;
                }
                if (a._state.status === B.NOAUTH && "CAPABILITY" !== e[1] && "ALERT" !== e[1]) return;
                switch (e[1]) {
                  case "CAPABILITY":
                    a._state.numCapRecvs < 2 && a._state.numCapRecvs++, a.capabilities = e[2].split(" ").map(w);
                    break;

                  case "ENABLED":
                    a.enabledCapabilities = a.enabledCapabilities.concat(e[2].split(" ")), a.enabledCapabilities.sort();
                    break;

                  case "FLAGS":
                    a._state.status === B.BOXSELECTING && (a._state.box._flags = e[2].substr(1, e[2].length - 2).split(" ").map(function(e) {
                        return e.substr(1);
                    }));
                    break;

                  case "OK":
                    if (s = /^\[ALERT\] (.*)$/i.exec(e[2])) a.emit("alert", s[1]); else if (a._state.status === B.BOXSELECTING) {
                        var s;
                        if (s = /^\[UIDVALIDITY (\d+)\]/i.exec(e[2])) a._state.box.validity = s[1]; else if (s = /^\[UIDNEXT (\d+)\]/i.exec(e[2])) a._state.box._uidnext = parseInt(s[1]); else if (s = /^\[PERMANENTFLAGS \((.*)\)\]/i.exec(e[2])) {
                            a._state.box.permFlags = s[1].split(" ");
                            var o;
                            (o = a._state.box.permFlags.indexOf("\\*")) > -1 && (a._state.box._newKeywords = !0, 
                            a._state.box.permFlags.splice(o, 1)), a._state.box.keywords = a._state.box.permFlags.filter(function(e) {
                                return "\\" !== e[0];
                            });
                            for (var l = 0; l < a._state.box.keywords.length; l++) a._state.box.permFlags.splice(a._state.box.permFlags.indexOf(a._state.box.keywords[l]), 1);
                            a._state.box.permFlags = a._state.box.permFlags.map(function(e) {
                                return e.substr(1);
                            });
                        } else (s = /^\[HIGHESTMODSEQ (\d+)\]/i.exec(e[2])) ? a._state.box.highestModSeq = s[1] : (s = /^\[NOMODSEQ\]/i.exec(e[2])) && (a._state.box.highestModSeq = null);
                    }
                    break;

                  case "NAMESPACE":
                    p(e[2], a.namespaces);
                    break;

                  case "SEARCH":
                    a._state.requests[0].args.push(void 0 === e[2] || 0 === e[2].length ? [] : e[2].trim().split(" ").map(i));
                    break;

                  case "LIST":
                  case "XLIST":
                    var s;
                    if (null === a.delim && (s = /^\(\\No[sS]elect(?:[^)]*)\) (.+?) .*$/.exec(e[2]))) a.delim = "NIL" === s[1] ? !1 : s[1].substring(1, s[1].length - 1); else if (null !== a.delim) {
                        0 === a._state.requests[0].args.length && a._state.requests[0].args.push({}), s = /^\((.*)\) (.+?) "?([^"]+)"?$/.exec(e[2]);
                        var d = {
                            displayName: null,
                            attribs: s[1].split(" ").map(function(e) {
                                return e.substr(1).toUpperCase();
                            }),
                            delim: "NIL" === s[2] ? !1 : s[2].substring(1, s[2].length - 1),
                            children: null,
                            parent: null
                        }, u = s[3], m = a._state.requests[0].args[0];
                        if ('"' === u[0] && '"' === u[u.length - 1] && (u = u.substring(1, u.length - 1)), 
                        d.delim) {
                            var g = u.split(d.delim).filter(v), _ = null;
                            u = g.pop();
                            for (var l = 0, y = g.length; y > l; l++) m[g[l]] || (m[g[l]] = {
                                delim: d.delim
                            }), m[g[l]].children || (m[g[l]].children = {}), _ = m[g[l]], m = m[g[l]].children;
                            d.parent = _;
                        }
                        d.displayName = r(u), m[u] && (d.children = m[u].children), m[u] = d;
                    }
                    break;

                  case "VANISHED":
                    var b = !1;
                    0 === e[2].lastIndexOf("(EARLIER) ", 0) && (b = !0, e[2] = e[2].substring(10)), 
                    a.emit("vanished", h(e[2]), b);
                    break;

                  default:
                    if (/^\d+$/.test(e[1])) {
                        var S = a._state.requests[0] && a._state.requests[0].command.indexOf("NOOP") > -1 || a._state.isIdle && a._state.ext.idle.state === et;
                        switch (e[2]) {
                          case "EXISTS":
                            var E = a._state.box.messages.total, x = parseInt(e[1]);
                            a._state.box.messages.total = x, a._state.status !== B.BOXSELECTING && x > E && (a._state.box.messages.new = x - E, 
                            a.emit("mail", a._state.box.messages.new));
                            break;

                          case "RECENT":
                            a._state.box.messages.new = parseInt(e[1]);
                            break;

                          case "EXPUNGE":
                            a._state.box.messages.total > 0 && a._state.box.messages.total--, S && a.emit("deleted", parseInt(e[1], 10));
                            break;

                          default:
                            if (/^FETCH/.test(e[2])) {
                                var T = new c();
                                f(e[2].substring(e[2].indexOf("(") + 1, e[2].lastIndexOf(")")), "", T), T.seqno = parseInt(e[1], 10), 
                                a._state.requests.length && a._state.requests[0].command.indexOf("FETCH") > -1 ? (t = a._state.requests[0], 
                                t._fetcher.emit("message", T), T.emit("end")) : S && a.emit("msgupdate", T);
                            }
                        }
                    }
                }
            } else if ("A" === e[0][0] || "+" === e[0]) {
                if ("+" === e[0] && a._state.ext.idle.state === Z) return a._state.ext.idle.state = et, 
                process.nextTick(function() {
                    a._send();
                }), void 0;
                var N = !1;
                if (a._state.status === B.BOXSELECTING && ("OK" === e[1] ? (N = !0, a._state.status = B.BOXSELECTED) : (a._state.status = B.AUTH, 
                a._resetBox())), 0 === a._state.requests.length) return;
                var I = "+" !== e[0] ? a._findAndShiftRequestByPrefix(e[0]) : a._state.requests.shift();
                if (I.command.indexOf("RENAME") > -1 && (a._state.box.name = a._state.box._newName, 
                delete a._state.box._newName, N = !0), "function" == typeof I.callback) {
                    var C = null, k = I.args, A = I.command;
                    if ("+" === e[0]) {
                        if (a._state.requests.unshift(I), 0 === A.indexOf("APPEND")) return I.callback();
                        C = new Error("Unexpected continuation"), C.type = "continuation", C.serverResponse = "", 
                        C.request = A;
                    } else "OK" !== e[1] ? (C = new Error("Error while executing request: " + e[2]), 
                    C.type = e[1], C.serverResponse = e[2], C.request = A) : a._state.status === B.BOXSELECTED && (N ? k.unshift(a._state.box) : 0 !== A.indexOf("UID FETCH") && 0 !== A.indexOf("UID SEARCH") || 0 !== k.length || k.unshift([]));
                    k.unshift(C), I.callback.apply(I, k);
                }
                if (!I) {
                    if (a._state.status === B.NOCONNECT) return;
                    return console.error("IMAP: Somehow no recentReq for data:", e), void 0;
                }
                I.active && a._state.activeRequests--;
                var D = I.command;
                a._LOG && a._LOG.cmd_end(I.prefix, D, /^LOGIN$/.test(D) ? "***BLEEPING OUT LOGON***" : I.cmddata), 
                (0 !== a._state.requests.length || "LOGOUT" === D) && process.nextTick(function() {
                    a._send();
                }), a._state.isIdle = !0;
            } else "IDLE" === e[0] ? (a._state.requests.length && process.nextTick(function() {
                a._send();
            }), a._state.isIdle = !1, a._state.ext.idle.state = J, a._state.ext.idle.timeWaited = 0) : a._LOG && a._LOG.unknownResponse(e[0], e[1], e[2]);
        }
        function n(e) {
            return a._state.curData = a._state.curData ? T(a._state.curData, e) : e, a._state.curData;
        }
        function s(e) {
            a._state.curData = e ? new Buffer(e) : null, a._state.curDataMinLength = 0;
        }
        function o(e) {
            if (0 !== e.length) {
                var i, r, o = null;
                if (null === a._state.curExpected) {
                    var l = 0;
                    if (a._state.curDataMinLength) {
                        if (a._state.curData.length + e.length < a._state.curDataMinLength) return n(e), 
                        void 0;
                        l = a._state.curDataMinLength - a._state.curData.length, a._state.curDataMinLength = 0;
                    }
                    if (-1 === (o = N(e, l))) return n(e), void 0;
                    e.length >= o + 2 && a._unprocessed.unshift(e.slice(o + 2)), e = e.slice(0, o), 
                    e = n(e);
                }
                if (r = r || a._state.requests[0], r && null !== a._state.curExpected) {
                    var d = e;
                    if (a._state.curXferred += e.length, a._state.curXferred > a._state.curExpected) {
                        var u = e.length - (a._state.curXferred - a._state.curExpected), h = e.slice(u);
                        d = u > 0 ? e.slice(0, u) : void 0, h.length && a._unprocessed.unshift(h), r._done = 1, 
                        a._state.curExpected = null;
                    }
                    return d && d.length && (a._LOG && a._LOG.data(d.length, d), "headers" === r._msgtype ? (d.copy(a._state.curData, r.curPos, 0), 
                    r.curPos += d.length) : r._msg.emit("data", d)), r._done && ("headers" === r._msgtype && (r._headers = a._state.curData.toString("ascii")), 
                    s()), void 0;
                }
                if (r && 1 === r._done) {
                    var p;
                    return e[e.length - 1] === X && (p = e.toString("ascii", 0, e.length - 1).trim(), 
                    p.length && (r._desc += " " + p), f(r._desc, r._headers, r._msg), r._done = !1, 
                    a._state.curXferred = 0, a._state.curExpected = null, s(), r._msg.emit("end", r._msg)), 
                    void 0;
                }
                if (e[0] === W && (m = e.toString("ascii")) && P.test(m) && (i = q.exec(m))) {
                    var m, g = parseInt(i[1], 10), v = H.exec(e);
                    if (!v) return e = n(R), a._state.curDataMinLength = e.length + g, void 0;
                    a._state.curExpected = g;
                    var y = m.substring(m.indexOf("(") + 1).trim(), b = v[1], w = U.exec(y)[1];
                    r = a._findFetchRequest(w, b) || a._state.requests[0];
                    var S = new c();
                    return a._state.requests[0] !== r && (a._state.requests.splice(a._state.requests.indexOf(r), 1), 
                    a._state.requests.unshift(r)), S.seqno = parseInt(i[1], 10), r._desc = y, r._msg = S, 
                    S.size = a._state.curExpected, r._fetcher.emit("message", S), r._msgtype = 0 === b.indexOf("HEADER") ? "headers" : "body", 
                    "headers" === r._msgtype && (s(a._state.curExpected), r.curPos = 0), a._LOG && a._LOG.data(m.length, m), 
                    void 0;
                }
                if (s(), e.length) {
                    var E = e.toString("ascii");
                    a._LOG && a._LOG.data(E.length, E), t(_(E, " ", 3));
                }
            }
        }
        var a = this, l = function() {
            var t = function() {
                var t = !1, n = function(i) {
                    return i ? (e(i), void 0) : !t && a.capabilities.indexOf("NAMESPACE") > -1 ? (t = !0, 
                    a._send("NAMESPACE", null, n), void 0) : (a._send('LIST "" ""', null, e), void 0);
                };
                a._login(n);
            };
            0 === a._state.numCapRecvs ? a._send("CAPABILITY", null, t) : t();
        };
        e = e || M, this._reset(), this._LOG && this._LOG.connect(this._options.host, this._options.port), 
        this._state.conn = ("ssl" === this._options.crypto || this._options.crypto === !0 ? A : k).connect(this._options.port, this._options.host), 
        this._state.tmrConn = Y(this._fnTmrConn.bind(this, e), this._options.connTimeout), 
        this._state.conn.on("connect", function() {
            a._LOG && a._LOG.connected(), a._state.tmrConn && (V(a._state.tmrConn), a._state.tmrConn = null), 
            a._state.status === B.NOCONNECT && (a._state.status = B.NOGREET);
        }), this._state.postGreetingCallback = function() {
            return "starttls" === a._options.crypto ? (a._state.numCapRecvs = 0, a._send("STARTTLS", null, function(t) {
                if (t) {
                    var n = new Error("Server does not support STARTTLS");
                    n.type = "bad-security", e(n);
                } else a._state.conn.upgradeToSecure(), l();
            }), void 0) : (l(), void 0);
        }, this._state.conn.on("data", function(e) {
            try {
                for (a._unprocessed.push(e); a._unprocessed.length; ) o(a._unprocessed.shift());
            } catch (t) {
                throw console.error("Explosion while processing data", t), "stack" in t && console.error("Stack:", t.stack), 
                t;
            }
        }), this._state.conn.on("close", function() {
            a._reset(), this._LOG && this._LOG.closed(), a.emit("close");
        }), this._state.conn.on("error", function(t) {
            try {
                var n;
                if (t && "object" == typeof t && /^Security/.test(t.name) && (t = new Error("SSL error"), 
                n = t.type = "bad-security"), a._state.tmrConn && (V(a._state.tmrConn), a._state.tmrConn = null), 
                a._state.status === B.NOCONNECT) {
                    var i = new Error("Unable to connect. Reason: " + t);
                    i.type = n || "unresponsive-server", i.serverResponse = "", e(i);
                }
                a.emit("error", t), this._LOG && this._LOG.connError(t);
            } catch (r) {
                throw console.error("Error in imap onerror:", r), r;
            }
        });
    }, a.prototype.die = function() {
        this._state.conn && (this._state.conn.removeAllListeners(), this._state.conn.end()), 
        this._reset(), this._LOG && this._LOG.__die();
    }, a.prototype.isAuthenticated = function() {
        return this._state.status >= B.AUTH;
    }, a.prototype.logout = function(e) {
        if (!(this._state.status >= B.NOAUTH)) throw new Error("Not connected");
        this._send("LOGOUT", null, e);
    }, a.prototype.enable = function(e, t) {
        if (this._state.status < B.AUTH) throw new Error("Not connected or authenticated");
        this._send("ENABLE " + e.join(" "), t || M);
    }, a.prototype.openBox = function(e, t, n) {
        function i() {
            r._state.status = B.BOXSELECTING, r._state.box.name = e;
        }
        if (this._state.status < B.AUTH) throw new Error("Not connected or authenticated");
        this._state.status === B.BOXSELECTED && this._resetBox(), void 0 === n && (n = void 0 === t ? M : t, 
        t = !1);
        var r = this;
        this._send(t ? "EXAMINE" : "SELECT", ' "' + b(e) + '"', n, i);
    }, a.prototype.qresyncBox = function(e, t, n, i, r, s) {
        function o() {
            a._state.status = B.BOXSELECTING, a._state.box.name = e;
        }
        if (this._state.status < B.AUTH) throw new Error("Not connected or authenticated");
        if (-1 === this.enabledCapabilities.indexOf("QRESYNC")) throw new Error("QRESYNC is not enabled");
        this._state.status === B.BOXSELECTED && this._resetBox(), void 0 === s && (s = void 0 === t ? M : t, 
        t = !1);
        var a = this;
        this._send((t ? "EXAMINE" : "SELECT") + ' "' + b(e) + '"' + " (QRESYNC (" + n + " " + i + (r ? " " + r : "") + "))", s, o);
    }, a.prototype.closeBox = function(e) {
        var t = this;
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        this._send("CLOSE", null, function(n) {
            n || (t._state.status = B.AUTH, t._resetBox()), e(n);
        });
    }, a.prototype.removeDeleted = function(e) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        e = arguments[arguments.length - 1], this._send("EXPUNGE", null, e);
    }, a.prototype.getBoxes = function(e, t, n) {
        n = arguments[arguments.length - 1], arguments.length < 2 && (e = ""), arguments.length < 3 && (t = "*");
        var i, r = ' "' + b(e) + '" "' + b(t) + '"';
        -1 !== this.capabilities.indexOf("SPECIAL-USE") ? (i = "LIST", r += " RETURN (SPECIAL-USE)") : i = -1 !== this.capabilities.indexOf("XLIST") ? "XLIST" : "LIST", 
        this._send(i, r, n);
    }, a.prototype.addBox = function(e, t) {
        if (t = arguments[arguments.length - 1], "string" != typeof e || 0 === e.length) throw new Error("Mailbox name must be a string describing the full path of a new mailbox to be created");
        this._send("CREATE", ' "' + b(e) + '"', t);
    }, a.prototype.delBox = function(e, t) {
        if (t = arguments[arguments.length - 1], "string" != typeof e || 0 === e.length) throw new Error("Mailbox name must be a string describing the full path of an existing mailbox to be deleted");
        this._send("DELETE", ' "' + b(e) + '"', t);
    }, a.prototype.noop = function(e) {
        this._send("NOOP", "", e);
    }, a.prototype.renameBox = function(e, t, n) {
        if (n = arguments[arguments.length - 1], "string" != typeof e || 0 === e.length) throw new Error("Old mailbox name must be a string describing the full path of an existing mailbox to be renamed");
        if ("string" != typeof t || 0 === t.length) throw new Error("New mailbox name must be a string describing the full path of a new mailbox to be renamed to");
        this._state.status === B.BOXSELECTED && e === this._state.box.name && "INBOX" !== e && (this._state.box._newName = e), 
        this._send("RENAME", ' "' + b(e) + '" "' + b(t) + '"', n);
    }, a.prototype.search = function(e, t) {
        this._search("UID ", e, t);
    }, a.prototype._search = function(e, t, n) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        if (!Array.isArray(t)) throw new Error("Expected array for search options");
        this._send(e + "SEARCH", d(t, this.capabilities), n);
    }, a.prototype.append = function(e, t, n) {
        if ("function" == typeof t && (n = t, t = {}), t = t || {}, !("mailbox" in t)) {
            if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox specified or currently selected");
            t.mailbox = this._state.box.name;
        }
        var i = ' "' + b(t.mailbox) + '"';
        if ("flags" in t && (Array.isArray(t.flags) || (t.flags = Array(t.flags)), t.flags.length && (i += " (\\" + t.flags.join(" \\") + ")")), 
        "date" in t) {
            if (!(t.date instanceof Date)) throw new Error("Expected null or Date object for date");
            i += ' "' + o(t.date) + '"';
        }
        i += " {", i += e instanceof Blob ? e.size : Buffer.isBuffer(e) ? e.length : Buffer.byteLength(e), 
        i += "}";
        var r = this, s = 1;
        this._send("APPEND", i, function(t) {
            return t || 2 === s++ ? n(t) : ("string" == typeof e ? r._state.conn.write(Buffer(e + O)) : (r._state.conn.write(e), 
            r._state.conn.write(R)), this._LOG && this._LOG.sendData(e.length, e), void 0);
        });
    }, a.prototype.multiappend = function(e, t) {
        function n(e) {
            if ("flags" in e && (Array.isArray(e.flags) || (e.flags = Array(e.flags)), e.flags.length && (i += " (\\" + e.flags.join(" \\") + ")")), 
            "date" in e) {
                if (!(e.date instanceof Date)) throw new Error("Expected null or Date object for date");
                i += ' "' + o(e.date) + '"';
            }
            i += " {", i += l instanceof Blob ? l.size : Buffer.isBuffer(l) ? l.length : Buffer.byteLength(l), 
            i += "}";
        }
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox specified or currently selected");
        var i = ' "' + b(this._state.box.name) + '"', r = this, s = 1, a = !1, c = e[0], l = c.messageText;
        n(c), this._send("APPEND", i, function(o) {
            return o || a ? t(o, s - 1) : (r._state.conn.write("string" == typeof l ? Buffer(l) : l), 
            r._LOG && r._LOG.sendData(l.length, l), s < e.length ? (i = "", c = e[s++], l = c.messageText, 
            n(c), i += O, r._state.conn.write(Buffer(i)), r._LOG && r._LOG.sendData(i.length, i)) : (r._state.conn.write(R), 
            r._LOG && r._LOG.sendData(2, O), a = !0), void 0);
        });
    }, a.prototype.fetch = function(e, t) {
        return this._fetch("UID ", e, t);
    }, a.prototype._fetch = function(e, t, n) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        if (void 0 === t || null === t || Array.isArray(t) && 0 === t.length) throw new Error("Nothing to fetch");
        Array.isArray(t) || (t = [ t ]), u(t);
        var i, r = {
            markSeen: !1,
            request: {
                struct: !0,
                headers: !0,
                body: !1
            }
        }, s = "", o = this;
        if ("object" != typeof n && (n = {}), x(r, n, "request"), Array.isArray(r.request.headers)) i = "HEADER.FIELDS (" + r.request.headers.join(" ").toUpperCase() + ")"; else {
            if (Array.isArray(r.request.body)) {
                var a;
                if (2 !== r.request.body.length) throw new Error("Expected Array of length 2 for body byte range");
                if ("string" != typeof r.request.body[1] || !(a = /^([\d]+)\-([\d]+)$/.exec(r.request.body[1])) || parseInt(a[1]) >= parseInt(a[2])) throw new Error("Invalid body byte range format");
                s = "<" + parseInt(a[1]) + "." + parseInt(a[2]) + ">", r.request.body = r.request.body[0];
            }
            if ("boolean" == typeof r.request.headers && r.request.headers === !0) i = "HEADER"; else if ("boolean" == typeof r.request.body && r.request.body === !0) i = "TEXT"; else if ("string" == typeof r.request.body) if ("FULL" === r.request.body.toUpperCase()) i = ""; else {
                if (!/^([\d]+[\.]{0,1})*[\d]+$/.test(r.request.body)) throw new Error("Invalid body partID format");
                i = r.request.body;
            }
        }
        var c;
        if (1 === t.length && r.request.body) {
            var d = {};
            t.forEach(function(e) {
                d[e] = i;
            }), c = {
                uids: d,
                bodyPart: r.request.body
            };
        }
        var h = "";
        this.capabilities.indexOf("X-GM-EXT-1") > -1 ? h = "X-GM-THRID X-GM-MSGID X-GM-LABELS " : this.enabledCapabilities.indexOf("QRESYNC") > -1 && (h = "MODSEQ ");
        var p = " " + t.join(",") + " (" + h + "UID FLAGS INTERNALDATE" + (r.request.struct ? " BODYSTRUCTURE" : "") + ("string" == typeof i ? " BODY" + (r.markSeen ? "" : ".PEEK") + "[" + i + "]" + s : "") + ")", f = function(e) {
            var t = this._fetcher;
            e && t ? t.emit("error", e) : e && !t ? o.emit("error", e) : t && t.emit("end");
        };
        this._send(e + "FETCH", p, f, null, null, c);
        var m = new l();
        return this._state.requests[this._state.requests.length - 1]._fetcher = m, m;
    }, a.prototype.addFlags = function(e, t, n) {
        this._store("UID ", e, t, !0, n);
    }, a.prototype.delFlags = function(e, t, n) {
        this._store("UID ", e, t, !1, n);
    }, a.prototype.addKeywords = function(e, t, n) {
        return this._addKeywords("UID ", e, t, n);
    }, a.prototype._addKeywords = function(e, t, n, i) {
        if (!this._state.box._newKeywords) throw new Error("This mailbox does not allow new keywords to be added");
        this._store(e, t, n, !0, i);
    }, a.prototype.delKeywords = function(e, t, n) {
        this._store("UID ", e, t, !1, n);
    }, a.prototype.copy = function(e, t, n) {
        return this._copy("UID ", e, t, n);
    }, a.prototype._copy = function(e, t, n, i) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        Array.isArray(t) || (t = [ t ]), u(t), this._send(e + "COPY", " " + t.join(",") + ' "' + b(n) + '"', i);
    }, a.prototype.__defineGetter__("seq", function() {
        var e = this;
        return {
            move: function(t, n, i) {
                return e._move("", t, n, i);
            },
            copy: function(t, n, i) {
                return e._copy("", t, n, i);
            },
            delKeywords: function(t, n, i) {
                e._store("", t, n, !1, i);
            },
            addKeywords: function(t, n, i) {
                return e._addKeywords("", t, n, i);
            },
            delFlags: function(t, n, i) {
                e._store("", t, n, !1, i);
            },
            addFlags: function(t, n, i) {
                e._store("", t, n, !0, i);
            },
            fetch: function(t, n) {
                return e._fetch("", t, n);
            },
            search: function(t, n) {
                e._search("", t, n);
            }
        };
    }), a.prototype._fnTmrConn = function(e) {
        var t = new Error("Connection timed out");
        t.type = "timeout", e(t), this._state.conn.end();
    }, a.prototype._store = function(e, t, n, i, r) {
        if (this._state.status !== B.BOXSELECTED) throw new Error("No mailbox is currently selected");
        if (void 0 === t) throw new Error("The message ID(s) must be specified");
        if (Array.isArray(t) || (t = [ t ]), u(t), !Array.isArray(n) && "string" != typeof n || Array.isArray(n) && 0 === n.length) throw new Error((isKeywords ? "Keywords" : "Flags") + " argument must be a string or a non-empty Array");
        Array.isArray(n) || (n = [ n ]), n = n.join(" "), r = arguments[arguments.length - 1], 
        this._send(e + "STORE", " " + t.join(",") + " " + (i ? "+" : "-") + "FLAGS.SILENT (" + n + ")", r);
    }, a.prototype._login = function(e) {
        var t = this, n = function(n) {
            return n || (t._state.status = B.AUTH, 2 === t._state.numCapRecvs) ? (e(n), void 0) : (t._send("CAPABILITY", null, e), 
            void 0);
        };
        if (this._state.status === B.NOAUTH) {
            var i;
            if (this.capabilities.indexOf("LOGINDISABLED") > -1) return i = new Error("Logging in is disabled on this server"), 
            i.type = "server-maintenance", i.serverResponse = "LOGINDISABLED", e(i), void 0;
            if (-1 !== this.capabilities.indexOf("AUTH=XOAUTH") && "xoauth" in this._options) this._send("AUTHENTICATE XOAUTH " + b(this._options.xoauth), n); else if (this.capabilities.indexOf("AUTH=XOAUTH2") && "xoauth2" in this._options) this._send("AUTHENTICATE XOAUTH2 " + b(this._options.xoauth2), n); else {
                if (void 0 === this._options.username || void 0 === this._options.password) return i = new Error("Unsupported authentication mechanism(s) detected. Unable to login."), 
                i.type = "sucky-imap-server", i.serverResponse = "CAPABILITIES: " + this.capabilities.join(" "), 
                e(i), void 0;
                this._send("LOGIN", ' "' + b(this._options.username) + '" "' + b(this._options.password) + '"', n);
            }
        }
    }, a.prototype._reset = function() {
        this._state.tmrConn && V(this._state.tmrConn), this._state.status = B.NOCONNECT, 
        this._state.numCapRecvs = 0, this._state.requests = [], this._state.unsentRequests = [], 
        this._state.postGreetingCallback = null, this._state.isIdle = !0, this._state.ext.idle.state = J, 
        this._state.ext.idle.timeWaited = 0, this.namespaces = {
            personal: [],
            other: [],
            shared: []
        }, this.delim = null, this.capabilities = [], this._resetBox();
    }, a.prototype._resetBox = function() {
        this._state.box._uidnext = 0, this._state.box.validity = 0, this._state.box.highestModSeq = null, 
        this._state.box._flags = [], this._state.box._newKeywords = !1, this._state.box.permFlags = [], 
        this._state.box.keywords = [], this._state.box.name = null, this._state.box.messages.total = 0, 
        this._state.box.messages.new = 0;
    }, a.prototype._send = function(e, t, n, i, r, s) {
        var o;
        if (void 0 !== e && (o = {
            prefix: null,
            command: e,
            cmddata: t,
            callback: n,
            dispatch: i,
            args: [],
            fetchParams: s,
            active: !1
        }, r || (this._state.requests.push(o), this._state.unsentRequests.push(o))), this._state.ext.idle.state === Z || this._state.ext.idle.state === tt) return o;
        if (r) return this._writeRequest(o), o;
        var a = this._state.unsentRequests;
        if (0 === a.length) return null;
        if (0 === this._state.activeRequests && this._writeRequest(a.shift(), !0), this._state.lastRequest && this._state.lastRequest.fetchParams) for (;a.length && a[0].fetchParams; ) this._writeRequest(a.shift(), !0);
        return o;
    }, a.prototype._writeRequest = function(e, t) {
        var n = "", i = e.command, r = e.cmddata, s = e.dispatch;
        this._state.ext.idle.state === et && "DONE" !== i ? this._send("DONE", null, void 0, void 0, !0) : "IDLE" === i ? (n = "IDLE ", 
        this._state.ext.idle.state = Z) : "DONE" === i && (this._state.ext.idle.state = tt), 
        "IDLE" !== i && "DONE" !== i && (n = "A" + ++this._state.curId + " ", e.prefix = n, 
        this._state.lastRequest = e), s && s();
        var o, a = 0;
        for (o = 0; o < n.length; o++) K[a++] = n.charCodeAt(o);
        for (o = 0; o < i.length; o++) K[a++] = i.charCodeAt(o);
        if (r) if (r.length < K.length - 2) if ("string" == typeof r) for (o = 0; o < r.length; o++) K[a++] = r.charCodeAt(o); else K.set(r, a), 
        a += r.length; else this._state.conn.write(K.subarray(0, a)), "string" == typeof r ? this._state.conn.write(Buffer(r)) : this._state.conn.write(r), 
        this._state.conn.write(R), a = 0;
        a && (K[a++] = 13, K[a++] = 10, this._state.conn.write(K.subarray(0, a))), t && (e.active = !0, 
        this._state.activeRequests++), this._LOG && this._LOG.cmd_begin(n, i, /^LOGIN$/.test(i) ? "***BLEEPING OUT LOGON***" : r);
    }, I.inherits(c, D), I.inherits(l, D);
    const nt = /^\\Recent$/i;
    t.parseExpr = S;
    var it = t.LOGFAB = C.register(n, {
        ImapProtoConn: {
            type: C.CONNECTION,
            subtype: C.CLIENNT,
            events: {
                created: {},
                connect: {},
                connected: {},
                closed: {},
                sendData: {
                    length: !1
                },
                bypassCmd: {
                    prefix: !1,
                    cmd: !1
                },
                data: {
                    length: !1
                }
            },
            TEST_ONLY_events: {
                connect: {
                    host: !1,
                    port: !1
                },
                sendData: {
                    data: !1
                },
                data: {
                    data: C.TOSTRING
                }
            },
            errors: {
                connError: {
                    err: C.EXCEPTION
                },
                bad: {
                    msg: !1
                },
                unknownResponse: {
                    d0: !1,
                    d1: !1,
                    d2: !1
                }
            },
            asyncJobs: {
                cmd: {
                    prefix: !1,
                    cmd: !1
                }
            },
            TEST_ONLY_asyncJobs: {
                cmd: {
                    data: !1
                }
            }
        }
    });
}), define("mailapi/imap/probe", [ "imap", "exports" ], function(e, t) {
    function n(n, i, r) {
        var s = {
            host: i.hostname,
            port: i.port,
            crypto: i.crypto,
            username: n.username,
            password: n.password,
            connTimeout: t.CONNECT_TIMEOUT_MS
        };
        r && (s._logParent = r), console.log("PROBE:IMAP attempting to connect to", i.hostname), 
        this._conn = new e.ImapConnection(s), this._conn.connect(this.onLoggedIn.bind(this)), 
        this._conn.on("error", this.onError.bind(this)), this.tzOffset = null, this.blacklistedCapabilities = null, 
        this.onresult = null, this.error = null, this.errorDetails = {
            server: i.hostname
        };
    }
    t.CONNECT_TIMEOUT_MS = 3e4, t.ImapProber = n, n.prototype = {
        onLoggedIn: function(e) {
            return e ? (this.onError(e), void 0) : (o(this._conn, this.onGotTZOffset.bind(this)), 
            void 0);
        },
        onGotTZOffset: function(e, n) {
            return e ? (this.onError(e), void 0) : (console.log("PROBE:IMAP happy, TZ offset:", n / 36e5), 
            this.tzOffset = n, t.checkServerProblems(this._conn, this.onServerProblemsChecked.bind(this)), 
            void 0);
        },
        onServerProblemsChecked: function(e, t) {
            if (e) return this.onError(e), void 0;
            this.blacklistedCapabilities = t;
            var n = this._conn;
            this._conn = null, this.onresult && (this.onresult(this.error, n, this.tzOffset, t), 
            this.onresult = !1);
        },
        onError: function(e) {
            if (this.onresult) {
                console.warn("PROBE:IMAP sad.", e && e.name, "|", e && e.type, "|", e && e.message, "|", e && e.serverResponse);
                var t = i(e);
                this.error = t.name;
                try {
                    this._conn.die();
                } catch (n) {}
                this._conn = null, this.onresult(this.error, null, this.errorDetails), this.onresult = !1;
            }
        }
    };
    var i = t.normalizeError = function(e) {
        var t, n = !1, i = !0, r = !1;
        switch (e.type) {
          case "NO":
          case "no":
            n = !0, e.serverResponse ? (r = !0, i = !1, t = -1 !== e.serverResponse.indexOf("[ALERT] Application-specific password required") ? "needs-app-pass" : -1 !== e.serverResponse.indexOf("[ALERT] Your account is not enabled for IMAP use.") || -1 !== e.serverResponse.indexOf("[ALERT] IMAP access is disabled for your domain.") ? "imap-disabled" : "bad-user-or-pass") : (t = "unknown", 
            r = !1);
            break;

          case "BAD":
          case "bad":
            t = "bad-user-or-pass", r = !0, i = !1;
            break;

          case "server-maintenance":
            t = e.type, n = !0;
            break;

          case "bad-security":
            t = e.type, n = !0, i = !1;
            break;

          case "unresponsive-server":
          case "timeout":
            t = "unresponsive-server";
            break;

          default:
            t = "unknown";
        }
        return {
            name: t,
            reachable: n,
            retry: i,
            reportProblem: r
        };
    }, r = -252e5, s = t._extractTZFromHeaders = function(e) {
        for (var t = 0; t < e.length; t++) {
            var n = e[t];
            if ("received" === n.key) {
                var i = / ([+-]\d{4})/.exec(n.value);
                if (i) {
                    var r = 1e3 * 60 * 60 * parseInt(i[1].substring(1, 3), 10) + 1e3 * 60 * parseInt(i[1].substring(3, 5), 10);
                    return "-" === i[1].substring(0, 1) && (r *= -1), r;
                }
            }
        }
        return null;
    }, o = t.getTZOffset = function(e, t) {
        function n(e, n) {
            return e ? (t(e), void 0) : n.messages.total ? (i(n._uidnext - 1), void 0) : (t(null, r), 
            void 0);
        }
        function i(t) {
            e.search([ [ "UID", Math.max(1, t - 49) + ":" + t ] ], o.bind(null, t - 50));
        }
        function o(e, n, s) {
            if (!s.length) {
                if (0 > e) return t(null, r), void 0;
                i(e);
            }
            c = s, a(c.pop());
        }
        function a(n) {
            var i = e.fetch([ n ], {
                request: {
                    headers: [ "RECEIVED" ],
                    struct: !1,
                    body: !1
                }
            });
            i.on("message", function(e) {
                e.on("end", function() {
                    var n = s(e.msg.headers);
                    return null !== n ? (t(null, n), void 0) : (c.length ? a(c.pop()) : t(null, r), 
                    void 0);
                });
            }), i.on("error", function(e) {
                t(e);
            });
        }
        var c = null;
        e.openBox("INBOX", !0, n);
    };
    t.checkServerProblems = function(e, t) {
        function n(e) {
            for (var t in e) if ("inbox" === t.toLowerCase()) return !0;
            return !1;
        }
        e.hasCapability("SPECIAL-USE") || t(null, null), e.getBoxes(function(i, r) {
            return n(r) ? (t(null, null), void 0) : (e.blacklistCapability("SPECIAL-USE"), e.getBoxes(function(e, i) {
                n(i) ? t(null, [ "SPECIAL-USE" ]) : t("server-problem", null);
            }), void 0);
        });
    };
});