define("net", [ "require", "exports", "module", "util", "events", "mailapi/worker-router" ], function(e, t) {
    function n(e, t, n) {
        var i = {
            onopen: this._onconnect.bind(this),
            onerror: this._onerror.bind(this),
            ondata: this._ondata.bind(this),
            onclose: this._onclose.bind(this)
        }, s = a.register(function(e) {
            i[e.cmd](e.args);
        });
        this._sendMessage = s.sendMessage, this._unregisterWithRouter = s.unregister;
        var o = [ t, e, {
            useSSL: n,
            useSecureTransport: n,
            binaryType: "arraybuffer"
        } ];
        this._sendMessage("open", o), r.call(this), this.destroyed = !1;
    }
    var i = e("util"), r = e("events").EventEmitter, s = e("mailapi/worker-router"), a = s.registerInstanceType("netsocket");
    t.NetSocket = n, i.inherits(n, r), n.prototype.setTimeout = function() {}, n.prototype.setKeepAlive = function() {}, 
    n.prototype.write = function(e) {
        if (e instanceof Blob) return this._sendMessage("write", [ e ]), void 0;
        if (0 !== e.byteOffset || e.length !== e.buffer.byteLength) {
            var t = e.buffer.slice(e.byteOffset, e.byteOffset + e.length);
            this._sendMessage("write", [ t, 0, t.byteLength ], [ t ]);
        } else this._sendMessage("write", [ e.buffer, e.byteOffset, e.length ]);
    }, n.prototype.upgradeToSecure = function() {
        this._sendMessage("upgradeToSecure", []);
    }, n.prototype.end = function() {
        this.destroyed || (this._sendMessage("end"), this.destroyed = !0, this._unregisterWithRouter());
    }, n.prototype._onconnect = function() {
        this.emit("connect");
    }, n.prototype._onerror = function(e) {
        this.emit("error", e);
    }, n.prototype._ondata = function(e) {
        var t = Buffer(e);
        this.emit("data", t);
    }, n.prototype._onclose = function() {
        this.emit("close"), this.emit("end");
    }, t.connect = function(e, t, i) {
        return new n(e, t, !!i);
    };
}), define("pop3/transport", [ "exports" ], function(e) {
    function t(e, t) {
        var n = new Uint8Array(e.byteLength + t.byteLength);
        return n.set(e, 0), n.set(t, e.byteLength), n;
    }
    function n() {
        this.buffer = new Uint8Array(0), this.unprocessedLines = [];
    }
    function i(e, t) {
        this.lines = e, this.isMultiline = t, this.ok = this.lines[0][0] === u, this.err = !this.ok, 
        this.request = null;
    }
    function r(e, t, n, i) {
        this.command = e, this.args = t, this.expectMultiline = n, this.onresponse = i || null;
    }
    function s() {
        this.parser = new n(), this.onsend = function() {
            throw new Error("You must implement Pop3Protocol.onsend to send data.");
        }, this.unsentRequests = [], this.pipeline = !1, this.pendingRequests = [], this.closed = !1;
    }
    window.setTimeout.bind(window), window.clearTimeout.bind(window);
    var a = "\r".charCodeAt(0), o = "\n".charCodeAt(0), c = ".".charCodeAt(0), u = "+".charCodeAt(0);
    "-".charCodeAt(0), " ".charCodeAt(0);
    var d = new TextEncoder("utf-8", {
        fatal: !1
    }), l = new TextDecoder("utf-8", {
        fatal: !1
    });
    n.prototype.push = function(e) {
        for (var n = this.buffer = t(this.buffer, e), i = 0; i < n.length - 1; i++) if (n[i] === a && n[i + 1] === o) {
            var r = i + 1;
            this.unprocessedLines.push(n.slice(0, r + 1)), n = this.buffer = n.slice(r + 1), 
            i = -1;
        }
    }, n.prototype.extractResponse = function(e) {
        if (!this.unprocessedLines.length) return null;
        if (this.unprocessedLines[0][0] !== u && (e = !1), e) {
            for (var t = -1, n = 1; n < this.unprocessedLines.length; n++) {
                var r = this.unprocessedLines[n];
                if (3 === r.byteLength && r[0] === c && r[1] === a && r[2] === o) {
                    t = n;
                    break;
                }
            }
            if (-1 === t) return null;
            var s = this.unprocessedLines.splice(0, t + 1);
            s.pop();
            for (var n = 1; t > n; n++) s[n][0] === c && (s[n] = s[n].slice(1));
            return new i(s, !0);
        }
        return new i([ this.unprocessedLines.shift() ], !1);
    }, i.prototype.getStatusLine = function() {
        return this.getLineAsString(0).replace(/^(\+OK|-ERR) /, "");
    }, i.prototype.getLineAsString = function(e) {
        return l.decode(this.lines[e]);
    }, i.prototype.getLinesAsString = function() {
        for (var e = [], t = 0; t < this.lines.length; t++) e.push(this.getLineAsString(t));
        return e;
    }, i.prototype.getDataLines = function() {
        for (var e = [], t = 1; t < this.lines.length; t++) {
            var n = this.getLineAsString(t);
            e.push(n.slice(0, n.length - 2));
        }
        return e;
    }, i.prototype.getDataAsString = function() {
        for (var e = [], t = 1; t < this.lines.length; t++) e.push(this.getLineAsString(t));
        return e.join("");
    }, i.prototype.toString = function() {
        return this.getLinesAsString().join("\r\n");
    }, e.Request = r, r.prototype.toByteArray = function() {
        return d.encode(this.command + (this.args.length ? " " + this.args.join(" ") : "") + "\r\n");
    }, r.prototype._respondWithError = function(e) {
        var t = new i([ d.encode("-ERR " + e + "\r\n") ], !1);
        t.request = this, this.onresponse(t, null);
    }, e.Response = i, e.Pop3Protocol = s, s.prototype.sendRequest = function(e, t, n, i) {
        var s;
        return s = e instanceof r ? e : new r(e, t, n, i), this.closed ? (s._respondWithError("(request sent after connection closed)"), 
        void 0) : (this.pipeline || 0 === this.pendingRequests.length ? (this.onsend(s.toByteArray()), 
        this.pendingRequests.push(s)) : this.unsentRequests.push(s), void 0);
    }, s.prototype.onreceive = function(e) {
        this.parser.push(e);
        for (var t; ;) {
            var n = this.pendingRequests[0];
            if (t = this.parser.extractResponse(n && n.expectMultiline), !t) break;
            if (!n) {
                console.error("Unsolicited response from server: " + t);
                break;
            }
            t.request = n, this.pendingRequests.shift(), this.unsentRequests.length && this.sendRequest(this.unsentRequests.shift()), 
            n.onresponse && (t.err ? n.onresponse(t, null) : n.onresponse(null, t));
        }
    }, s.prototype.onclose = function() {
        this.closed = !0;
        var e = this.pendingRequests.concat(this.unsentRequests);
        this.pendingRequests = [], this.unsentRequests = [];
        for (var t = 0; t < e.length; t++) {
            var n = e[t];
            n._respondWithError("(connection closed, no response)");
        }
    };
}), define("mailparser/datetime", [ "require", "exports", "module" ], function() {
    this.strtotime = function(e, t) {
        var n, i, r, s = "", a = "";
        if (s = e, s = s.replace(/\s{2,}|^\s|\s$/g, " "), s = s.replace(/[\t\r\n]/g, ""), 
        "now" == s) return new Date().getTime() / 1e3;
        if (!isNaN(a = Date.parse(s))) return a / 1e3;
        t = t ? new Date(1e3 * t) : new Date(), s = s.toLowerCase();
        var o = {
            day: {
                sun: 0,
                mon: 1,
                tue: 2,
                wed: 3,
                thu: 4,
                fri: 5,
                sat: 6
            },
            mon: {
                jan: 0,
                feb: 1,
                mar: 2,
                apr: 3,
                may: 4,
                jun: 5,
                jul: 6,
                aug: 7,
                sep: 8,
                oct: 9,
                nov: 10,
                dec: 11
            }
        }, c = function(e) {
            var n = e[2] && "ago" == e[2], i = (i = "last" == e[0] ? -1 : 1) * (n ? -1 : 1);
            switch (e[0]) {
              case "last":
              case "next":
                switch (e[1].substring(0, 3)) {
                  case "yea":
                    t.setFullYear(t.getFullYear() + i);
                    break;

                  case "mon":
                    t.setMonth(t.getMonth() + i);
                    break;

                  case "wee":
                    t.setDate(t.getDate() + 7 * i);
                    break;

                  case "day":
                    t.setDate(t.getDate() + i);
                    break;

                  case "hou":
                    t.setHours(t.getHours() + i);
                    break;

                  case "min":
                    t.setMinutes(t.getMinutes() + i);
                    break;

                  case "sec":
                    t.setSeconds(t.getSeconds() + i);
                    break;

                  default:
                    var r;
                    if ("undefined" != typeof (r = o.day[e[1].substring(0, 3)])) {
                        var s = r - t.getDay();
                        0 == s ? s = 7 * i : s > 0 ? "last" == e[0] && (s -= 7) : "next" == e[0] && (s += 7), 
                        t.setDate(t.getDate() + s);
                    }
                }
                break;

              default:
                if (!/\d+/.test(e[0])) return !1;
                switch (i *= parseInt(e[0], 10), e[1].substring(0, 3)) {
                  case "yea":
                    t.setFullYear(t.getFullYear() + i);
                    break;

                  case "mon":
                    t.setMonth(t.getMonth() + i);
                    break;

                  case "wee":
                    t.setDate(t.getDate() + 7 * i);
                    break;

                  case "day":
                    t.setDate(t.getDate() + i);
                    break;

                  case "hou":
                    t.setHours(t.getHours() + i);
                    break;

                  case "min":
                    t.setMinutes(t.getMinutes() + i);
                    break;

                  case "sec":
                    t.setSeconds(t.getSeconds() + i);
                }
            }
            return !0;
        };
        if (i = s.match(/^(\d{2,4}-\d{2}-\d{2})(?:\s(\d{1,2}:\d{2}(:\d{2})?)?(?:\.(\d+))?)?$/), 
        null != i) {
            i[2] ? i[3] || (i[2] += ":00") : i[2] = "00:00:00", r = i[1].split(/-/g);
            for (n in o.mon) o.mon[n] == r[1] - 1 && (r[1] = n);
            return r[0] = parseInt(r[0], 10), r[0] = r[0] >= 0 && r[0] <= 69 ? "20" + (r[0] < 10 ? "0" + r[0] : r[0] + "") : r[0] >= 70 && r[0] <= 99 ? "19" + r[0] : r[0] + "", 
            parseInt(this.strtotime(r[2] + " " + r[1] + " " + r[0] + " " + i[2]) + (i[4] ? i[4] / 1e3 : ""), 10);
        }
        var u = "([+-]?\\d+\\s(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday)|(last|next)\\s(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday))(\\sago)?";
        if (i = s.match(new RegExp(u, "gi")), null == i) return !1;
        for (n = 0; n < i.length; n++) if (!c(i[n].split(" "))) return !1;
        return t.getTime() / 1e3;
    };
}), define("mailparser/streams", [ "require", "exports", "module", "stream", "util", "mimelib", "encoding", "crypto" ], function(e, t, n) {
    function i() {
        a.call(this), this.writable = !0, this.checksum = d.createHash("md5"), this.length = 0, 
        this.current = "";
    }
    function r(e) {
        a.call(this), this.writable = !0, this.checksum = d.createHash("md5"), this.length = 0, 
        this.charset = e || "UTF-8", this.current = void 0;
    }
    function s(e) {
        a.call(this), this.writable = !0, this.checksum = d.createHash("md5"), this.length = 0, 
        this.charset = e || "UTF-8", this.current = "";
    }
    var a = e("stream").Stream, o = e("util"), c = e("mimelib"), u = e("encoding"), d = e("crypto");
    n.exports.Base64Stream = i, n.exports.QPStream = r, n.exports.BinaryStream = s, 
    o.inherits(i, a), i.prototype.write = function(e) {
        return this.handleInput(e), !0;
    }, i.prototype.end = function(e) {
        return this.handleInput(e), this.emit("end"), {
            length: this.length,
            checksum: this.checksum.digest("hex")
        };
    }, i.prototype.handleInput = function(e) {
        if (e && e.length) {
            e = (e || "").toString("utf-8");
            var t = 0;
            this.current += e.replace(/[^\w\+\/=]/g, "");
            var n = new Buffer(this.current.substr(0, this.current.length - this.current.length % 4), "base64");
            n.length && (this.length += n.length, this.checksum.update(n), this.emit("data", n)), 
            this.current = (t = this.current.length % 4) ? this.current.substr(-t) : "";
        }
    }, o.inherits(r, a), r.prototype.write = function(e) {
        return this.handleInput(e), !0;
    }, r.prototype.end = function(e) {
        return this.handleInput(e), this.flush(), this.emit("end"), {
            length: this.length,
            checksum: this.checksum.digest("hex")
        };
    }, r.prototype.handleInput = function(e) {
        e && e.length && (e = (e || "").toString("utf-8"), e.match(/^\r\n/) && (e = e.substr(2)), 
        "string" != typeof this.current ? this.current = e : this.current += "\r\n" + e);
    }, r.prototype.flush = function() {
        var e = c.decodeQuotedPrintable(this.current, !1, this.charset);
        "binary" == this.charset.toLowerCase() || (e = "utf-8" != this.charset.toLowerCase() ? u.convert(e, "utf-8", this.charset) : new Buffer(e, "utf-8")), 
        this.length += e.length, this.checksum.update(e), this.emit("data", e);
    }, o.inherits(s, a), s.prototype.write = function(e) {
        return e && e.length && (this.length += e.length, this.checksum.update(e), this.emit("data", e)), 
        !0;
    }, s.prototype.end = function(e) {
        return e && e.length && this.emit("data", e), this.emit("end"), {
            length: this.length,
            checksum: this.checksum.digest("hex")
        };
    };
}), define("mailparser/mailparser", [ "require", "exports", "module", "stream", "util", "mimelib", "./datetime", "encoding", "./streams", "crypto" ], function(e, t, n) {
    function i(e) {
        r.call(this), this.writable = !0, this.options = e || {}, this._state = l.header, 
        this._remainder = "", this.mimeTree = this._createMimeNode(), this._currentNode = this.mimeTree, 
        this._currentNode.priority = "normal", this._fileNames = {}, this._multipartTree = [], 
        this.mailData = {}, this._lineCounter = 0, this._lineFeed = !1, this._headersSent = !1;
    }
    var r = e("stream").Stream, s = e("util"), a = e("mimelib"), o = e("./datetime"), c = e("encoding"), u = e("./streams"), d = e("crypto");
    n.exports.MailParser = i;
    var l = {
        header: 1,
        body: 2,
        finished: 3
    };
    s.inherits(i, r), i.prototype.write = function(e, t) {
        return this._write(e, t) && process.nextTick(this._process.bind(this)), !0;
    }, i.prototype.end = function(e, t) {
        this._write(e, t), this.options.debug && this._remainder && console.log("REMAINDER: " + this._remainder), 
        process.nextTick(this._process.bind(this, !0));
    }, i.prototype._write = function(e, t) {
        return "string" == typeof e && (e = new Buffer(e, t)), e = e && e.toString("binary") || "", 
        this._lineFeed && "\n" === e.charAt(0) && (e = e.substr(1)), this._lineFeed = "\r" === e.substr(-1), 
        e && e.length ? (this._remainder += e, !0) : !1;
    }, i.prototype._process = function(e) {
        e = !!e;
        var t, n, i, r = this._remainder.split(/\r?\n|\r/);
        for (e || (this._remainder = r.pop(), this._remainder.length > 1048576 && (this._remainder = this._remainder.replace(/(.{1048576}(?!\r?\n|\r))/g, "$&\n"))), 
        n = 0, i = r.length; i > n; n++) t = r[n], this.options.unescapeSMTP && ".." == t.substr(0, 2) && (t = t.substr(1)), 
        this.options.debug && console.log("LINE " + ++this._lineCounter + " (" + this._state + "): " + t), 
        !(this._state == l.header && this._processStateHeader(t) === !0 || this._state == l.body && this._processStateBody(t) === !0);
        e && (this._state == l.header && this._remainder && (this._processStateHeader(this._remainder), 
        this._headersSent || (this.emit("headers", this._currentNode.parsedHeaders), this._headersSent = !0)), 
        (this._currentNode.content || this._currentNode.stream) && this._finalizeContents(), 
        this._state = l.finished, process.nextTick(this._processMimeTree.bind(this)));
    }, i.prototype._processStateHeader = function(e) {
        var t, n, i = this._currentNode.headers.length - 1, r = !1;
        return e.length ? (e.match(/^\s+/) && i >= 0 ? this._currentNode.headers[i] += " " + e.trim() : (this._currentNode.headers.push(e.trim()), 
        i >= 0 && this._processHeaderLine(i)), !1) : (i >= 0 && this._processHeaderLine(i), 
        this._headersSent || (this.emit("headers", this._currentNode.parsedHeaders), this._headersSent = !0), 
        this._state = l.body, i >= 0 && this._processHeaderLine(i), this._currentNode.parentNode || this._currentNode.meta.contentType || (this._currentNode.meta.contentType = "text/plain"), 
        r = [ "text/plain", "text/html" ].indexOf(this._currentNode.meta.contentType || "") >= 0, 
        !r || this._currentNode.meta.contentDisposition && "inline" != this._currentNode.meta.contentDisposition ? r && !([ "attachment", "inline" ].indexOf(this._currentNode.meta.contentDisposition) >= 0) || this._currentNode.meta.mimeMultipart || (this._currentNode.attachment = !0) : this._currentNode.attachment = !1, 
        this._currentNode.attachment && (this._currentNode.checksum = d.createHash("md5"), 
        this._currentNode.meta.generatedFileName = this._generateFileName(this._currentNode.meta.fileName, this._currentNode.meta.contentType), 
        n = this._currentNode.meta.generatedFileName.split(".").pop().toLowerCase(), "application/octet-stream" == this._currentNode.meta.contentType && a.contentTypes[n] && (this._currentNode.meta.contentType = a.contentTypes[n]), 
        t = this._currentNode.meta, this.options.streamAttachments ? (this._currentNode.stream = "base64" == this._currentNode.meta.transferEncoding ? new u.Base64Stream() : "quoted-printable" == this._currentNode.meta.transferEncoding ? new u.QPStream("binary") : new u.BinaryStream(), 
        t.stream = this._currentNode.stream, this.emit("attachment", t)) : this._currentNode.content = void 0), 
        !0);
    }, i.prototype._processStateBody = function(e) {
        var t, n, i, r = !1;
        if ("--" == e.substr(0, 2)) for (t = 0, n = this._multipartTree.length; n > t; t++) {
            if (e == "--" + this._multipartTree[t].boundary) {
                (this._currentNode.content || this._currentNode.stream) && this._finalizeContents(), 
                i = this._createMimeNode(this._multipartTree[t].node), this._multipartTree[t].node.childNodes.push(i), 
                this._currentNode = i, this._state = l.header, r = !0;
                break;
            }
            if (e == "--" + this._multipartTree[t].boundary + "--") {
                (this._currentNode.content || this._currentNode.stream) && this._finalizeContents(), 
                this._currentNode = this._multipartTree[t].node.parentNode ? this._multipartTree[t].node.parentNode : this._multipartTree[t].node, 
                this._state = l.body, r = !0;
                break;
            }
        }
        return r ? !0 : ([ "text/plain", "text/html" ].indexOf(this._currentNode.meta.contentType || "") >= 0 && !this._currentNode.attachment ? this._handleTextLine(e) : this._currentNode.attachment && this._handleAttachmentLine(e), 
        !1);
    }, i.prototype._processHeaderLine = function(e) {
        var t, n, i, r;
        if (e = e || 0, (r = this._currentNode.headers[e]) && "string" == typeof r) {
            switch (i = r.split(":"), t = i.shift().toLowerCase().trim(), n = i.join(":").trim(), 
            t) {
              case "content-type":
                this._parseContentType(n);
                break;

              case "mime-version":
                this._currentNode.useMIME = !0;
                break;

              case "date":
                this._currentNode.meta.date = new Date(1e3 * o.strtotime(n) || Date.now());
                break;

              case "to":
                this._currentNode.to = this._currentNode.to && this._currentNode.to.length ? this._currentNode.to.concat(a.parseAddresses(n)) : a.parseAddresses(n);
                break;

              case "from":
                this._currentNode.from = this._currentNode.from && this._currentNode.from.length ? this._currentNode.from.concat(a.parseAddresses(n)) : a.parseAddresses(n);
                break;

              case "cc":
                this._currentNode.cc = this._currentNode.cc && this._currentNode.cc.length ? this._currentNode.cc.concat(a.parseAddresses(n)) : a.parseAddresses(n);
                break;

              case "bcc":
                this._currentNode.bcc = this._currentNode.bcc && this._currentNode.bcc.length ? this._currentNode.bcc.concat(a.parseAddresses(n)) : a.parseAddresses(n);
                break;

              case "x-priority":
              case "x-msmail-priority":
              case "importance":
                n = this._parsePriority(n), this._currentNode.priority = n;
                break;

              case "message-id":
                this._currentNode.meta.messageId = this._trimQuotes(n);
                break;

              case "references":
                this._parseReferences(n);
                break;

              case "in-reply-to":
                this._parseInReplyTo(n);
                break;

              case "thread-index":
                this._currentNode.meta.threadIndex = n;
                break;

              case "content-transfer-encoding":
                this._currentNode.meta.transferEncoding = n.toLowerCase();
                break;

              case "subject":
                this._currentNode.subject = this._encodeString(n);
                break;

              case "content-disposition":
                this._parseContentDisposition(n);
                break;

              case "content-id":
                this._currentNode.meta.contentId = this._trimQuotes(n);
            }
            this._currentNode.parsedHeaders[t] ? (Array.isArray(this._currentNode.parsedHeaders[t]) || (this._currentNode.parsedHeaders[t] = [ this._currentNode.parsedHeaders[t] ]), 
            this._currentNode.parsedHeaders[t].push(this._replaceMimeWords(n))) : this._currentNode.parsedHeaders[t] = this._replaceMimeWords(n), 
            this._currentNode.headers[e] = {
                key: t,
                value: n
            };
        }
    }, i.prototype._createMimeNode = function(e) {
        var t = {
            parentNode: e || this._currentNode || null,
            headers: [],
            parsedHeaders: {},
            meta: {},
            childNodes: []
        };
        return t;
    }, i.prototype._parseHeaderLineWithParams = function(e) {
        var t, n, i = {};
        n = e.split(";"), i.defaultValue = n.shift().toLowerCase();
        for (var r = 0, s = n.length; s > r; r++) e = n[r].split("="), t = e.shift().trim().toLowerCase(), 
        e = e.join("=").trim(), e = this._trimQuotes(e), i[t] = e;
        return i;
    }, i.prototype._parseContentType = function(e) {
        var t;
        return e = this._parseHeaderLineWithParams(e), e && (e.defaultValue ? (e.defaultValue = e.defaultValue.toLowerCase(), 
        this._currentNode.meta.contentType = e.defaultValue, "multipart/" == e.defaultValue.substr(0, "multipart/".length) && (this._currentNode.meta.mimeMultipart = e.defaultValue.substr("multipart/".length))) : this._currentNode.meta.contentType = "application/octet-stream", 
        e.charset && (e.charset = e.charset.toLowerCase(), "win-" == e.charset.substr(0, 4) ? e.charset = "windows-" + e.charset.substr(4) : "ks_c_5601-1987" == e.charset ? e.charset = "cp949" : e.charset.match(/^utf\d/) ? e.charset = "utf-" + e.charset.substr(3) : e.charset.match(/^latin[\-_]?\d/) ? e.charset = "iso-8859-" + e.charset.replace(/\D/g, "") : e.charset.match(/^(us\-)?ascii$/) && (e.charset = "utf-8"), 
        this._currentNode.meta.charset = e.charset), e.format && (this._currentNode.meta.textFormat = e.format.toLowerCase()), 
        e.delsp && (this._currentNode.meta.textDelSp = e.delsp.toLowerCase()), e.boundary && (this._currentNode.meta.mimeBoundary = e.boundary), 
        !this._currentNode.meta.fileName && (t = this._detectFilename(e)) && (this._currentNode.meta.fileName = t), 
        e.boundary && (this._currentNode.meta.mimeBoundary = e.boundary, this._multipartTree.push({
            boundary: e.boundary,
            node: this._currentNode
        }))), e;
    }, i.prototype._detectFilename = function(e) {
        var t, n, i, r = "", s = 0;
        if (e.name) return this._replaceMimeWords(e.name);
        if (e.filename) return this._replaceMimeWords(e.filename);
        if (e["name*"]) r = e["name*"]; else if (e["filename*"]) r = e["filename*"]; else if (e["name*0*"]) for (;e["name*" + s + "*"]; ) r += e["name*" + s++ + "*"]; else if (e["filename*0*"]) for (;e["filename*" + s + "*"]; ) r += e["filename*" + s++ + "*"];
        return r && (t = r.split("'"), n = t.shift(), i = t.pop()) ? this._replaceMimeWords(this._replaceMimeWords("=?" + (n || "us-ascii") + "?Q?" + i.replace(/%/g, "=") + "?=")) : "";
    }, i.prototype._parseContentDisposition = function(e) {
        var t;
        e = this._parseHeaderLineWithParams(e), e && (e.defaultValue && (this._currentNode.meta.contentDisposition = e.defaultValue.trim().toLowerCase()), 
        (t = this._detectFilename(e)) && (this._currentNode.meta.fileName = t));
    }, i.prototype._parseReferences = function(e) {
        this._currentNode.references = (this._currentNode.references || []).concat((e || "").toString().trim().split(/\s+/).map(this._trimQuotes.bind(this)));
    }, i.prototype._parseInReplyTo = function(e) {
        this._currentNode.inReplyTo = (this._currentNode.inReplyTo || []).concat((e || "").toString().trim().split(/\s+/).map(this._trimQuotes.bind(this)));
    }, i.prototype._parsePriority = function(e) {
        if (e = e.toLowerCase().trim(), !isNaN(parseInt(e, 10))) return e = parseInt(e, 10) || 0, 
        3 == e ? "normal" : e > 3 ? "low" : "high";
        switch (e) {
          case "non-urgent":
          case "low":
            return "low";

          case "urgent":
          case "hight":
            return "high";
        }
        return "normal";
    }, i.prototype._handleTextLine = function(e) {
        var t = this._currentNode.meta.transferEncoding;
        "base64" === t ? "string" != typeof this._currentNode.content ? this._currentNode.content = e.trim() : this._currentNode.content += e.trim() : "quoted-printable" === t || "flowed" != this._currentNode.meta.textFormat ? "string" != typeof this._currentNode.content ? this._currentNode.content = e : this._currentNode.content += "\n" + e : "string" != typeof this._currentNode.content ? this._currentNode.content = e : this._currentNode.content.match(/[ ]{1,}$/) ? ("yes" == this._currentNode.meta.textDelSp && (this._currentNode.content = this._currentNode.content.replace(/\s+$/, "")), 
        this._currentNode.content += e) : this._currentNode.content += "\n" + e;
    }, i.prototype._handleAttachmentLine = function(e) {
        this._currentNode.attachment && (this._currentNode.stream ? this._currentNode.streamStarted ? this._currentNode.stream.write(new Buffer("\r\n" + e, "binary")) : (this._currentNode.streamStarted = !0, 
        this._currentNode.stream.write(new Buffer(e, "binary"))) : "content" in this._currentNode && ("string" != typeof this._currentNode.content ? this._currentNode.content = e : this._currentNode.content += "\r\n" + e));
    }, i.prototype._finalizeContents = function() {
        var e;
        this._currentNode.content && (this._currentNode.attachment ? (this._currentNode.content = "quoted-printable" == this._currentNode.meta.transferEncoding ? a.decodeQuotedPrintable(this._currentNode.content, !1, "binary") : "base64" == this._currentNode.meta.transferEncoding ? new Buffer(this._currentNode.content.replace(/[^\w\+\/=]/g, ""), "base64") : new Buffer(this._currentNode.content, "binary"), 
        this._currentNode.checksum.update(this._currentNode.content), this._currentNode.meta.checksum = this._currentNode.checksum.digest("hex"), 
        this._currentNode.meta.length = this._currentNode.content.length) : ("text/html" == this._currentNode.meta.contentType && (this._currentNode.meta.charset = this._detectHTMLCharset(this._currentNode.content) || this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1"), 
        "quoted-printable" == this._currentNode.meta.transferEncoding ? (this._currentNode.content = a.decodeQuotedPrintable(this._currentNode.content, !1, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1"), 
        "flowed" === this._currentNode.meta.textFormat && (this._currentNode.content = "yes" === this._currentNode.meta.textDelSp ? this._currentNode.content.replace(/ \n/g, "") : this._currentNode.content.replace(/ \n/g, " "))) : this._currentNode.content = "base64" == this._currentNode.meta.transferEncoding ? a.decodeBase64(this._currentNode.content, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1") : this._convertStringToUTF8(this._currentNode.content))), 
        this._currentNode.stream && (e = this._currentNode.stream.end() || {}, e.checksum && (this._currentNode.meta.checksum = e.checksum), 
        e.length && (this._currentNode.meta.length = e.length));
    }, i.prototype._processMimeTree = function() {
        var e, t, n, i, r = {};
        if (this.mailData = {
            html: [],
            text: [],
            alternatives: [],
            attachments: []
        }, this.mimeTree.meta.mimeMultipart ? this._walkMimeTree(this.mimeTree) : this._processMimeNode(this.mimeTree, 0), 
        this.mailData.html.length) for (n = 0, i = this.mailData.html.length; i > n; n++) !r.html || this.mailData.html[n].level < e ? (r.html && (r.alternatives || (r.alternatives = []), 
        r.alternatives.push({
            contentType: "text/html",
            content: r.html
        })), e = this.mailData.html[n].level, r.html = this.mailData.html[n].content) : (r.alternatives || (r.alternatives = []), 
        r.alternatives.push({
            contentType: "text/html",
            content: this.mailData.html[n].content
        }));
        if (this.mailData.text.length) for (n = 0, i = this.mailData.text.length; i > n; n++) !r.text || this.mailData.text[n].level < t ? (r.text && (r.alternatives || (r.alternatives = []), 
        r.alternatives.push({
            contentType: "text/plain",
            content: r.text
        })), t = this.mailData.text[n].level, r.text = this.mailData.text[n].content) : (r.alternatives || (r.alternatives = []), 
        r.alternatives.push({
            contentType: "text/plain",
            content: this.mailData.text[n].content
        }));
        if (r.headers = this.mimeTree.parsedHeaders, this.mimeTree.subject && (r.subject = this.mimeTree.subject), 
        this.mimeTree.references && (r.references = this.mimeTree.references), this.mimeTree.inReplyTo && (r.inReplyTo = this.mimeTree.inReplyTo), 
        this.mimeTree.priority && (r.priority = this.mimeTree.priority), this.mimeTree.from && (r.from = this.mimeTree.from), 
        this.mimeTree.to && (r.to = this.mimeTree.to), this.mimeTree.cc && (r.cc = this.mimeTree.cc), 
        this.mimeTree.bcc && (r.bcc = this.mimeTree.bcc), this.mailData.attachments.length) for (r.attachments = [], 
        n = 0, i = this.mailData.attachments.length; i > n; n++) r.attachments.push(this.mailData.attachments[n].content);
        process.nextTick(this.emit.bind(this, "end", r));
    }, i.prototype._walkMimeTree = function(e, t) {
        t = t || 1;
        for (var n = 0, i = e.childNodes.length; i > n; n++) this._processMimeNode(e.childNodes[n], t, e.meta.mimeMultipart), 
        this._walkMimeTree(e.childNodes[n], t + 1);
    }, i.prototype._processMimeNode = function(e, t, n) {
        var i, r;
        if (t = t || 0, e.attachment) {
            if (e.meta = e.meta || {}, e.content && (e.meta.content = e.content), this.mailData.attachments.push({
                content: e.meta || {},
                level: t
            }), this.options.showAttachmentLinks && "mixed" == n && this.mailData.html.length) for (i = 0, 
            r = this.mailData.html.length; r > i; i++) if (this.mailData.html[i].level == t) return this._joinHTMLAttachment(this.mailData.html[i], e.meta), 
            void 0;
        } else switch (e.meta.contentType) {
          case "text/html":
            if ("mixed" == n && this.mailData.html.length) for (i = 0, r = this.mailData.html.length; r > i; i++) if (this.mailData.html[i].level == t) return this._joinHTMLNodes(this.mailData.html[i], e.content), 
            void 0;
            return this.mailData.html.push({
                content: this._updateHTMLCharset(e.content || ""),
                level: t
            }), void 0;

          case "text/plain":
            return this.mailData.text.push({
                content: e.content || "",
                level: t
            }), void 0;
        }
    }, i.prototype._joinHTMLNodes = function(e, t) {
        var n = !1;
        t = (t || "").toString("utf-8").trim(), t = t.replace(/^\s*<\!doctype( [^>]*)?>/gi, ""), 
        t = t.replace(/<head( [^>]*)?>(.*)<\/head( [^>]*)?>/gi, "").replace(/<\/?html( [^>]*)?>/gi, "").trim(), 
        t.replace(/<body(?: [^>]*)?>(.*)<\/body( [^>]*)?>/gi, function(e, n) {
            t = n.trim();
        }), e.content = (e.content || "").toString("utf-8").trim(), e.content = e.content.replace(/<\/body( [^>]*)?>/i, function(e) {
            return n = !0, "<br/>\n" + t + e;
        }), n || (e.content += "<br/>\n" + t);
    }, i.prototype._joinHTMLAttachment = function(e, t) {
        var n, i, r = !1, s = t.generatedFileName.replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;");
        n = t.cid || (t.cid = t.generatedFileName + "@node"), i = '\n<div class="mailparser-attachment"><a href="cid:' + n + '">&lt;' + s + "&gt;</a></div>", 
        e.content = (e.content || "").toString("utf-8").trim(), e.content = e.content.replace(/<\/body( [^>]*)?>/i, function(e) {
            return r = !0, "<br/>\n" + i + e;
        }), r || (e.content += "<br/>\n" + i);
    }, i.prototype._convertString = function(e, t, n) {
        return n = (n || "utf-8").toUpperCase(), t = (t || "utf-8").toUpperCase(), e = "string" == typeof e ? new Buffer(e, "binary") : e, 
        n == t ? e : e = c.convert(e, n, t);
    }, i.prototype._convertStringToUTF8 = function(e) {
        return e = this._convertString(e, this._currentNode.meta.charset || this.options.defaultCharset || "iso-8859-1").toString("utf-8");
    }, i.prototype._encodeString = function(e) {
        return e = this._replaceMimeWords(this._convertStringToUTF8(e));
    }, i.prototype._replaceMimeWords = function(e) {
        return e.replace(/(=\?[^?]+\?[QqBb]\?[^?]+\?=)\s+(?==\?[^?]+\?[QqBb]\?[^?]+\?=)/g, "$1").replace(/\=\?[^?]+\?[QqBb]\?[^?]+\?=/g, function(e) {
            return a.decodeMimeWord(e.replace(/\s/g, ""));
        }.bind(this));
    }, i.prototype._trimQuotes = function(e) {
        return e = (e || "").trim(), ('"' == e.charAt(0) && '"' == e.charAt(e.length - 1) || "'" == e.charAt(0) && "'" == e.charAt(e.length - 1) || "<" == e.charAt(0) && ">" == e.charAt(e.length - 1)) && (e = e.substr(1, e.length - 2)), 
        e;
    }, i.prototype._generateFileName = function(e, t) {
        var n, i = "";
        return t && (i = a.contentTypesReversed[t], i = i ? "." + i : ""), e = e || "attachment" + i, 
        e = e.toString().split(/[\/\\]+/).pop().replace(/^\.+/, "") || "attachment", e in this._fileNames ? (this._fileNames[e]++, 
        n = e.substr((e.lastIndexOf(".") || 0) + 1), n == e ? e += "-" + this._fileNames[e] : e = e.substr(0, e.length - n.length - 1) + "-" + this._fileNames[e] + "." + n) : this._fileNames[e] = 0, 
        e;
    }, i.prototype._updateHTMLCharset = function(e) {
        return e = e.replace(/\n/g, "\0").replace(/<meta[^>]*>/gi, function(e) {
            return e.match(/http\-equiv\s*=\s*"?content\-type/i) ? '<meta http-equiv="content-type" content="text/html; charset=utf-8" />' : e.match(/\scharset\s*=\s*['"]?[\w\-]+["'\s>\/]/i) ? '<meta charset="utf-8"/>' : e;
        }).replace(/\u0000/g, "\n");
    }, i.prototype._detectHTMLCharset = function(e) {
        var t, n, i;
        return " string" != typeof e && (e = e.toString("ascii")), (i = e.match(/<meta\s+http-equiv=["']content-type["'][^>]*?>/i)) && (n = i[0]), 
        n && (t = n.match(/charset\s?=\s?([a-zA-Z\-_:0-9]*);?/), t && (t = (t[1] || "").trim().toLowerCase())), 
        !t && (i = e.match(/<meta\s+charset=["']([^'"<\/]*?)["']/i)) && (t = (i[1] || "").trim().toLowerCase()), 
        t;
    };
}), define("mailapi/imap/imapchew", [ "mimelib", "mailapi/db/mail_rep", "../mailchew", "exports" ], function(e, t, n, i) {
    function r(t) {
        var n = /^([^']*)'([^']*)'(.+)$/.exec(t);
        return n ? e.parseMimeWords("=?" + (n[1] || "us-ascii") + "?Q?" + n[3].replace(/%/g, "=") + "?=") : null;
    }
    function s(n) {
        function i(e) {
            var t = e.encoding.toLowerCase();
            return "base64" === t ? Math.floor(57 * e.size / 78) : "quoted-printable" === t ? e.size : e.size;
        }
        function s(n) {
            function s(e) {
                return "<" === e[0] ? e.slice(1, -1) : e;
            }
            function a(e, n) {
                return t.makeAttachmentPart({
                    name: n || "unnamed-" + ++u,
                    contentId: e.id ? s(e.id) : null,
                    type: (e.type + "/" + e.subtype).toLowerCase(),
                    part: e.partID,
                    encoding: e.encoding && e.encoding.toLowerCase(),
                    sizeEstimate: i(e),
                    file: null
                });
            }
            function l(e) {
                return t.makeBodyPart({
                    type: e.subtype,
                    part: e.partID,
                    sizeEstimate: e.size,
                    amountDownloaded: 0,
                    isDownloaded: 0 === e.size,
                    _partInfo: e.size ? e : null,
                    content: ""
                });
            }
            var h, p, f = n[0];
            if (h = f.params && f.params.name ? e.parseMimeWords(f.params.name) : f.params && f.params["name*"] ? r(f.params["name*"]) : f.disposition && f.disposition.params && f.disposition.params.filename ? e.parseMimeWords(f.disposition.params.filename) : f.disposition && f.disposition.params && f.disposition.params["filename*"] ? r(f.disposition.params["filename*"]) : null, 
            p = f.disposition ? f.disposition.type.toLowerCase() : f.id ? "inline" : h || "text" !== f.type ? "attachment" : "inline", 
            "text" !== f.type && "image" !== f.type && (p = "attachment"), "application" === f.type && ("pgp-signature" === f.subtype || "pkcs7-signature" === f.subtype)) return !0;
            if ("attachment" === p) return o.push(a(f, h)), !0;
            switch (f.type) {
              case "image":
                return d.push(a(f, h)), !0;

              case "text":
                if ("plain" === f.subtype || "html" === f.subtype) return c.push(l(f)), !0;
            }
            return !1;
        }
        function a(e) {
            var t, n = e[0];
            switch (n.subtype) {
              case "alternative":
                for (t = e.length - 1; t >= 1; t--) {
                    var i = e[t][0];
                    switch (i.type) {
                      case "text":
                        break;

                      case "multipart":
                        if (a(e[t])) return !0;
                        break;

                      default:
                        continue;
                    }
                    switch (i.subtype) {
                      case "html":
                      case "plain":
                        if (s(e[t])) return !0;
                    }
                }
                return !1;

              case "mixed":
              case "signed":
              case "related":
                for (t = 1; t < e.length; t++) e[t].length > 1 ? a(e[t]) : s(e[t]);
                return !0;

              default:
                return console.warn("Ignoring multipart type:", n.subtype), !1;
            }
        }
        var o = [], c = [], u = 0, d = [];
        return n.structure.length > 1 ? a(n.structure) : s(n.structure), {
            bodyReps: c,
            attachments: o,
            relatedParts: d
        };
    }
    i.chewHeaderAndBodyStructure = function(e, n, i) {
        var r = s(e), a = {};
        return a.header = t.makeHeaderInfo({
            id: i,
            srvid: e.id,
            suid: n + "/" + i,
            guid: e.msg.meta.messageId,
            author: e.msg.from && e.msg.from[0] || {
                address: "missing-address@example.com"
            },
            to: "to" in e.msg ? e.msg.to : null,
            cc: "cc" in e.msg ? e.msg.cc : null,
            bcc: "bcc" in e.msg ? e.msg.bcc : null,
            replyTo: "reply-to" in e.msg.parsedHeaders ? e.msg.parsedHeaders["reply-to"] : null,
            date: e.date,
            flags: e.flags,
            hasAttachments: r.attachments.length > 0,
            subject: e.msg.subject || null,
            snippet: null
        }), a.bodyInfo = t.makeBodyInfo({
            date: e.date,
            size: 0,
            attachments: r.attachments,
            relatedParts: r.relatedParts,
            references: e.msg.references,
            bodyReps: r.bodyReps
        }), a;
    }, i.updateMessageWithFetch = function(e, t, i, r, s) {
        var a = t.bodyReps[i.bodyRepIndex];
        (!i.bytes || r.bytesFetched < i.bytes[1]) && (a.isDownloaded = !0, a._partInfo = null), 
        !a.isDownloaded && r.buffer && (a._partInfo.pendingBuffer = r.buffer), a.amountDownloaded += r.bytesFetched;
        var o = n.processMessageContent(r.text, a.type, a.isDownloaded, i.createSnippet, s);
        i.createSnippet && (e.snippet = o.snippet), a.isDownloaded && (a.content = o.content);
    }, i.selectSnippetBodyRep = function(e, t) {
        if (e.snippet) return -1;
        for (var n = t.bodyReps, r = n.length, s = 0; r > s; s++) if (i.canBodyRepFillSnippet(n[s])) return s;
        return -1;
    }, i.canBodyRepFillSnippet = function(e) {
        return e && "plain" === e.type || "html" === e.type;
    }, i.calculateBytesToDownloadForImapBodyDisplay = function(e) {
        var t = 0;
        return e.bodyReps.forEach(function(e) {
            e.isDownloaded || (t += e.sizeEstimate - e.amountDownloaded);
        }), e.relatedParts.forEach(function(e) {
            e.file || (t += e.sizeEstimate);
        }), t;
    };
}), define("pop3/mime_mapper", [], function() {
    return {
        _typeToExtensionMap: {
            "image/jpeg": "jpg",
            "image/png": "png",
            "image/gif": "gif",
            "image/bmp": "bmp",
            "audio/mpeg": "mp3",
            "audio/mp4": "m4a",
            "audio/ogg": "ogg",
            "audio/webm": "webm",
            "audio/3gpp": "3gp",
            "audio/amr": "amr",
            "video/mp4": "mp4",
            "video/mpeg": "mpg",
            "video/ogg": "ogg",
            "video/webm": "webm",
            "video/3gpp": "3gp",
            "application/vcard": "vcf",
            "text/vcard": "vcf",
            "text/x-vcard": "vcf"
        },
        _extensionToTypeMap: {
            jpg: "image/jpeg",
            jpeg: "image/jpeg",
            jpe: "image/jpeg",
            png: "image/png",
            gif: "image/gif",
            bmp: "image/bmp",
            mp3: "audio/mpeg",
            m4a: "audio/mp4",
            m4b: "audio/mp4",
            m4p: "audio/mp4",
            m4r: "audio/mp4",
            aac: "audio/aac",
            opus: "audio/ogg",
            amr: "audio/amr",
            mp4: "video/mp4",
            mpeg: "video/mpeg",
            mpg: "video/mpeg",
            ogv: "video/ogg",
            ogx: "video/ogg",
            webm: "video/webm",
            "3gp": "video/3gpp",
            ogg: "video/ogg",
            vcf: "text/vcard"
        },
        _parseExtension: function(e) {
            var t = e.split(".");
            return t.length > 1 ? t.pop() : "";
        },
        isSupportedType: function(e) {
            return e in this._typeToExtensionMap;
        },
        isSupportedExtension: function(e) {
            return e in this._extensionToTypeMap;
        },
        isFilenameMatchesType: function(e, t) {
            var n = this._parseExtension(e), i = this.guessTypeFromExtension(n);
            return i == t;
        },
        guessExtensionFromType: function(e) {
            return this._typeToExtensionMap[e];
        },
        guessTypeFromExtension: function(e) {
            return this._extensionToTypeMap[e];
        },
        guessTypeFromFileProperties: function(e, t) {
            var n = this._parseExtension(e), i = this.isSupportedType(t) ? t : this.guessTypeFromExtension(n);
            return i || "";
        },
        ensureFilenameMatchesType: function(e, t) {
            if (!this.isFilenameMatchesType(e, t)) {
                var n = this.guessExtensionFromType(t);
                n && (e += "." + n);
            }
            return e;
        }
    };
}), define("pop3/pop3", [ "module", "exports", "rdcommon/log", "net", "crypto", "./transport", "mailparser/mailparser", "../mailapi/imap/imapchew", "../mailapi/syncbase", "./mime_mapper", "../mailapi/allback" ], function(e, t, n, i, r, s, a, o, c, u, d) {
    function l(e) {
        return r.createHash("md5").update(e).digest("hex").toLowerCase();
    }
    function h(e, t, n, i) {
        var r = [], s = e.meta.contentType.split("/"), a = {};
        if (a.type = s[0], a.subtype = s[1], a.params = {}, a.params.boundary = e.meta.mimeBoundary || null, 
        a.params.format = e.meta.textFormat || null, a.params.charset = e.meta.charset || null, 
        a.params.name = e.meta.fileName || null, e.meta.contentDisposition && (a.disposition = {
            type: e.meta.contentDisposition,
            params: {}
        }, e.meta.fileName && (a.disposition.params.filename = e.meta.fileName)), a.partID = t || "1", 
        a.id = e.meta.contentId, a.encoding = "binary", a.size = e.content && e.content.length || 0, 
        a.description = null, a.lines = null, a.md5 = null, null != e.content && ("text" === a.type && e.content.length && "\n" === e.content[e.content.length - 1] && (e.content = e.content.slice(0, -1), 
        a.size--), n[a.partID] = e.content, i === e && (n.partial = a.partID)), r.push(a), 
        e.childNodes.length) for (var o = 0; o < e.childNodes.length; o++) {
            var c = e.childNodes[o];
            r.push(h(c, a.partID + "." + (o + 1), n, i));
        }
        return r;
    }
    function p(e) {
        var t = "";
        if (Array.isArray(e)) return e.forEach(function(e) {
            t += p(e) + "\n";
        }), t;
        for (var n = 0; n < e.length; n++) {
            var i = String.fromCharCode(e[n]);
            t += "\r" === i ? "\\r" : "\n" === i ? "\\n" : i;
        }
        return t;
    }
    var f = window.setTimeout.bind(window), m = window.clearTimeout.bind(window);
    t.setTimeoutFuncs = function(e, t) {
        f = e, m = t;
    };
    var g = t.Pop3Client = function(e, t) {
        if (this.options = e = e || {}, e.host = e.host || null, e.username = e.username || null, 
        e.password = e.password || null, e.port = e.port || null, e.crypto = e.crypto || !1, 
        e.connTimeout = e.connTimeout || 3e4, e.debug = e.debug || !1, e.authMethods = [ "apop", "sasl", "user-pass" ], 
        this._LOG = e._logParent ? v.Pop3Client(this, e._logParent, Date.now() % 1e3) : null, 
        e.preferredAuthMethod) {
            var n = e.authMethods.indexOf(e.preferredAuthMethod);
            -1 !== n && e.authMethods.splice(n, 1), e.authMethods.unshift(e.preferredAuthMethod);
        }
        if (e.crypto === !0 ? e.crypto = "ssl" : e.crypto || (e.crypto = "plain"), !e.port && (e.port = {
            plain: 110,
            starttls: 110,
            ssl: 995
        }[e.crypto], !e.port)) throw new Error("Invalid crypto option for Pop3Client: " + e.crypto);
        this.state = "disconnected", this.authMethod = null, this.idToUidl = {}, this.uidlToId = {}, 
        this.idToSize = {}, this._messageList = null, this._greetingLine = null, this.protocol = new s.Pop3Protocol(), 
        this.socket = i.connect(e.port, e.host, "ssl" === e.crypto);
        var r = f(function() {
            this.state = "disconnected", r && (m(r), r = null), t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: "Could not connect to " + e.host + ":" + e.port + " with " + e.crypto + " encryption."
            });
        }.bind(this), e.connTimeout);
        e.debug && this.attachDebugLogging(), this.socket.on("data", this.protocol.onreceive.bind(this.protocol)), 
        this.protocol.onsend = this.socket.write.bind(this.socket), this.socket.on("connect", function() {
            r && (m(r), r = null), this.state = "greeting";
        }.bind(this)), this.socket.on("error", function(e) {
            r && (m(r), r = null), t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: "Socket exception: " + JSON.stringify(e),
                exception: e
            });
        }.bind(this)), this.socket.on("close", function() {
            this.protocol.onclose(), this.die();
        }.bind(this)), this.protocol.pendingRequests.push(new s.Request(null, [], !1, function(e, n) {
            return e ? (t && t({
                scope: "connection",
                request: null,
                name: "unresponsive-server",
                message: e.getStatusLine(),
                response: e
            }), void 0) : (this._greetingLine = n.getLineAsString(0), this._maybeUpgradeConnection(function(e) {
                return e ? (t && t(e), void 0) : (this._thenAuthorize(function(e) {
                    e || (this.state = "ready"), t && t(e);
                }), void 0);
            }.bind(this)), void 0);
        }.bind(this)));
    };
    g.prototype.disconnect = g.prototype.die = function() {
        "disconnected" !== this.state && (this.state = "disconnected", this.socket.end());
    }, g.prototype.attachDebugLogging = function() {
        this.socket.on("data", function(e) {
            var t = p(e), n = -1 === t.indexOf("-ERR") ? "[32m" : "[31m";
            dump("<-- " + n + t + "[0;37m\n");
        });
        var e = this.socket.write;
        this.socket.write = function(t) {
            var n = p(t);
            return n = n.replace(/(AUTH|USER|PASS|APOP)(.*?)\\r\\n/g, "$1 ***CREDENTIALS HIDDEN***\\r\\n"), 
            dump("--> [0;33m" + n + "[0;37m\n"), e.apply(this, arguments);
        }.bind(this.socket);
    }, g.prototype._getCapabilities = function() {
        this.protocol.sendRequest("CAPA", [], !0, function(e, t) {
            if (e) this.capabilities = {}; else for (var n = t.getDataLines(), i = 0; i < n.length; i++) {
                var r = n[i].split(" ");
                this.capabilities[r[0]] = r.slice(1);
            }
        }.bind(this));
    }, g.prototype._maybeUpgradeConnection = function(e) {
        "starttls" === this.options.crypto ? (this.state = "starttls", this.protocol.sendRequest("STLS", [], !1, function(t) {
            return t ? (e && e({
                scope: "connection",
                request: t.request,
                name: "bad-security",
                message: t.getStatusLine(),
                response: t
            }), void 0) : (this.socket.upgradeToSecure(), e(), void 0);
        }.bind(this))) : e();
    }, g.prototype._thenAuthorize = function(e) {
        this.state = "authorization", this.authMethod = this.options.authMethods.shift();
        var t, n = this.options.username, i = this.options.password;
        switch (this.authMethod) {
          case "apop":
            var r = /<.*?>/.exec(this._greetingLine || ""), s = r && r[0];
            s ? (t = l(s + i), this.protocol.sendRequest("APOP", [ n, t ], !1, function(t) {
                t ? (this._greetingLine = null, this._thenAuthorize(e)) : e();
            }.bind(this))) : this._thenAuthorize(e);
            break;

          case "sasl":
            t = btoa(n + "\0" + n + "\0" + i), this.protocol.sendRequest("AUTH", [ "PLAIN", t ], !1, function(t) {
                t ? this._thenAuthorize(e) : e();
            }.bind(this));
            break;

          case "user-pass":
          default:
            this.protocol.sendRequest("USER", [ n ], !1, function(t) {
                return t ? (e && e({
                    scope: "authentication",
                    request: t.request,
                    name: "bad-user-or-pass",
                    message: t.getStatusLine(),
                    response: t
                }), void 0) : (this.protocol.sendRequest("PASS", [ i ], !1, function(t) {
                    return t ? (e && e({
                        scope: "authentication",
                        request: t.request,
                        name: "bad-user-or-pass",
                        message: t.getStatusLine(),
                        response: t
                    }), void 0) : (e(), void 0);
                }.bind(this)), void 0);
            }.bind(this));
        }
    }, g.prototype.quit = function(e) {
        this.state = "disconnected", this.protocol.sendRequest("QUIT", [], !1, function(t) {
            this.disconnect(), t ? e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }) : e && e();
        }.bind(this));
    }, g.prototype._loadMessageList = function(e) {
        return this._messageList ? (e(null, this._messageList), void 0) : (this.protocol.sendRequest("UIDL", [], !0, function(t, n) {
            if (t) return e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }), void 0;
            for (var i = n.getDataLines(), r = 0; r < i.length; r++) {
                var s = i[r].split(" "), a = s[0], o = s[1];
                this.idToUidl[a] = o, this.uidlToId[o] = a;
            }
        }.bind(this)), this.protocol.sendRequest("LIST", [], !0, function(t, n) {
            if (t) return e && e({
                scope: "mailbox",
                request: t.request,
                name: "server-problem",
                message: t.getStatusLine(),
                response: t
            }), void 0;
            for (var i = n.getDataLines(), r = [], s = 0; s < i.length; s++) {
                var a = i[s].split(" "), o = a[0], c = parseInt(a[1], 10);
                this.idToSize[o] = c, r.unshift({
                    uidl: this.idToUidl[o],
                    size: c,
                    number: o
                });
            }
            this._messageList = r, e && e(null, r);
        }.bind(this)), void 0);
    }, g.prototype.listMessages = function(e, t) {
        var n = e.filter, i = e.progress, r = e.checkpointInterval || null, s = e.maxMessages || 1/0, a = e.checkpoint, o = [];
        this._loadMessageList(function(e, c) {
            if (e) return t && t(e), void 0;
            for (var u = 0, l = 0, h = [], p = 0, f = 0; f < c.length; f++) {
                var m = c[f];
                !n || n(m.uidl) ? h.length < s ? (u += m.size, h.push(m)) : o.push(m) : p++;
            }
            console.log("POP3: listMessages found " + h.length + " new, " + o.length + " overflow, and " + p + " seen messages. New UIDLs:"), 
            h.forEach(function(e) {
                console.log("POP3: " + e.size + " bytes: " + e.uidl);
            });
            var g = h.length;
            r || (r = g);
            var v = function() {
                if (console.log("POP3: Next batch. Messages left: " + h.length), !h.length) return console.log("POP3: Sync complete. " + g + " messages synced, " + o.length + " overflow messages."), 
                t && t(null, g, o), void 0;
                var e = h.splice(0, r), n = d.latch();
                e.forEach(function(e) {
                    var t = n.defer();
                    this.downloadPartialMessageByNumber(e.number, function(n, r) {
                        l += e.size, i && i({
                            totalBytes: u,
                            bytesFetched: l,
                            size: e.size,
                            message: r
                        }), t(n);
                    });
                }.bind(this)), n.then(function() {
                    console.log("POP3: Checkpoint."), a ? a(v) : v();
                });
            }.bind(this);
            v();
        }.bind(this));
    }, g.prototype.downloadMessageByUidl = function(e, t) {
        this._loadMessageList(function(n) {
            n ? t && t(n) : this.downloadMessageByNumber(this.uidlToId[e], t);
        }.bind(this));
    }, g.prototype.downloadPartialMessageByNumber = function(e, t) {
        var n = Math.floor(c.POP3_SNIPPET_SIZE_GOAL / 80);
        this.protocol.sendRequest("TOP", [ e, n ], !0, function(n, i) {
            if (n) return t && t({
                scope: "message",
                request: n.request,
                name: "server-problem",
                message: n.getStatusLine(),
                response: n
            }), void 0;
            var r = this.idToSize[e], s = i.getDataAsString(), a = !r || s.length < r;
            t(null, this.parseMime(s, a, e));
        }.bind(this));
    }, g.prototype.downloadMessageByNumber = function(e, t) {
        this.protocol.sendRequest("RETR", [ e ], !0, function(n, i) {
            return n ? (t && t({
                scope: "message",
                request: n.request,
                name: "server-problem",
                message: n.getStatusLine(),
                response: n
            }), void 0) : (t(null, this.parseMime(i.getDataAsString(), !1, e)), void 0);
        }.bind(this));
    }, g.parseMime = function(e) {
        return g.prototype.parseMime.call(this, e);
    }, g.prototype.parseMime = function(e, t, n) {
        var i = new a.MailParser();
        i._write(e), i._process(!0);
        var r, s = i.mimeTree, d = t ? i._currentNode : null, l = n && this.idToSize[n] || e.length, p = {}, f = {
            id: n && this.idToUidl[n],
            msg: s,
            date: s.meta.date && s.meta.date.valueOf(),
            flags: [],
            structure: h(s, "1", p, d)
        }, m = o.chewHeaderAndBodyStructure(f, null, null), g = o.selectSnippetBodyRep(m.header, m.bodyInfo), v = {}, y = 0, _ = p.partial;
        for (var b in p) "partial" !== b && b !== _ && (y += p[b].length, v[b] = p[b].length);
        _ && (v[_] = l - y);
        for (var w = 0; w < m.bodyInfo.bodyReps.length; w++) {
            var x = m.bodyInfo.bodyReps[w];
            if (r = p[x.part], null != r) {
                var N = {
                    bytes: _ === x.part ? [ -1, -1 ] : null,
                    bodyRepIndex: w,
                    createSnippet: w === g
                };
                x.size = v[x.part];
                var E = {
                    bytesFetched: r.length,
                    text: r
                };
                o.updateMessageWithFetch(m.header, m.bodyInfo, N, E, this._LOG);
            }
        }
        for (var w = 0; w < m.bodyInfo.relatedParts.length; w++) {
            var T = m.bodyInfo.relatedParts[w];
            T.sizeEstimate = v[T.part], r = p[T.part], null != r && _ !== T.part && (T.file = new Blob([ r ], {
                type: T.type
            }));
        }
        for (var w = 0; w < m.bodyInfo.attachments.length; w++) {
            var S = m.bodyInfo.attachments[w];
            r = p[S.part], S.sizeEstimate = v[S.part], null != r && _ !== S.part && u.isSupportedType(S.type) && (S.file = new Blob([ r ], {
                type: S.type
            }));
        }
        return t && !m.header.hasAttachments && (s.parsedHeaders["x-ms-has-attach"] || "mixed" === s.meta.mimeMultipart || l > c.POP3_INFER_ATTACHMENTS_SIZE) && (m.header.hasAttachments = !0), 
        m.bodyInfo.bodyReps.push({
            type: "fake",
            part: "fake",
            sizeEstimate: 0,
            amountDownloaded: 0,
            isDownloaded: !t,
            content: null,
            size: 0
        }), m.header.bytesToDownloadForBodyDisplay = t ? l : 0, m;
    };
    var v = t.LOGFAB = n.register(e, {
        Pop3Client: {
            type: n.CONNECTION,
            subtype: n.CLIENT,
            events: {},
            TEST_ONLY_events: {},
            errors: {
                htmlParseError: {
                    ex: n.EXCEPTION
                },
                htmlSnippetError: {
                    ex: n.EXCEPTION
                },
                textChewError: {
                    ex: n.EXCEPTION
                },
                textSnippetError: {
                    ex: n.EXCEPTION
                }
            },
            asyncJobs: {}
        }
    });
    g._LOG = v.Pop3Client();
});